/********************************** (C) COPYRIGHT *******************************
* File Name          : ch32v30x_usbotg_device.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/06/06
* Description        : This file provides all the USBOTG firmware functions.
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/
#include "ch32v30x_usbotg_device.h"


/******************************************************************************/
/* ȫֱ */
/* Endpoint Buffer */
__attribute__ ((aligned(4))) UINT8 EP0_DatabufHD[64]; //ep0(64)
__attribute__ ((aligned(4))) UINT8 EP3_DatabufHD[128+1023];  //ep3_out(RX 128)+ep3_in(TX 128)


PUINT8  pEP0_RAM_Addr;                       //ep0(64)
PUINT8  pEP3_RAM_Addr;                       //ep3_out(128)+ep3_in(128)

#if 1
volatile u8 D_flag=0;
const UINT8 *pDescr;
volatile UINT8  USBHD_Dev_SetupReqCode = 0xFF;                                  /* USBOTG豸Setup */
volatile UINT16 USBHD_Dev_SetupReqLen = 0x00;                                   /* USBOTG豸Setup */
volatile UINT8  USBHD_Dev_SetupReqValueH = 0x00;                                /* USBOTG豸SetupValueֽ */
volatile UINT8  USBHD_Dev_Config = 0x00;                                        /* USBOTG豸ֵ */
volatile UINT8  USBHD_Dev_Address = 0x00;                                       /* USBOTG豸ֵַ */
volatile UINT8  USBHD_Dev_SleepStatus = 0x00;                                   /* USBOTG豸˯״̬ */
volatile UINT8  USBHD_Dev_EnumStatus = 0x00;                                    /* USBOTG豸ö״̬ */
volatile UINT8  USBHD_Dev_Endp0_Tog = 0x01;                                     /* USBOTG豸˵0ͬ־ */
volatile UINT8  USBHD_Dev_Speed = 0x01;                                         /* USBOTG豸ٶ */


volatile UINT8   DevConfig;
volatile UINT8   SetupReqCode;
volatile UINT16  SetupReqLen;
#endif

#define buf_size 1024*10

u8 buf[buf_size]={0};
u8 * pbuf;
u8 * pbuf_tail;
u8 * pbuf_head;
u16 buf_value=0;
u8 time=0;
u16 EP3_RX_len=0;
/******************************************************************************/
/* Device Descriptor */
const UINT8  MyDevDescrHD[] =
{
    0x12, 0x01, 0x02, 0x00, 0x00, 0x00, 0x00, DEF_USBD_UEP0_SIZE,
    0x86, 0x1A, 0xE1, 0xE6,
    0x00, 0x01, 0x01, 0x02, 0x00, 0x01,
};


/* USB(ȫ) */
UINT8  MyCfgDescr_FS[ ] =
{
#if 1
        /* Configuration 1 */
         0x09,                                 /* bLength */
         USB_DESC_TYPE_CONFIGURATION,          /* bDescriptorType */
         LOBYTE(USB_AUDIO_CONFIG_DESC_SIZ),    /* wTotalLength */
         HIBYTE(USB_AUDIO_CONFIG_DESC_SIZ),
         0x03,                                 /* bNumInterfaces  audio+speaker AS+mic AS*/
         0x01,                                 /* bConfigurationValue */
         0x00,                                 /* iConfiguration */
         0x80,                                 /* bmAttributes: Bus Powered according to user configuration */
         USBD_MAX_POWER,                       /* MaxPower (mA) */
         /* 09 byte*/
#endif
         /*19Byte audio*/
#if 1
         /* USB audio Standard interface descriptor */
         AUDIO_INTERFACE_DESC_SIZE,            /* bLength */
         USB_DESC_TYPE_INTERFACE,              /* bDescriptorType */
         0x00,                                 /* bInterfaceNumber */
         0x00,                                 /* bAlternateSetting */
         0x00,                                 /* bNumEndpoints */
         USB_DEVICE_CLASS_AUDIO,               /* bInterfaceClass */
         AUDIO_SUBCLASS_AUDIOCONTROL,          /* bInterfaceSubClass */
         AUDIO_PROTOCOL_UNDEFINED,             /* bInterfaceProtocol */
         0x00,                                 /* iInterface */
         /* 09 byte*/

         /* USB audio Class-specific AC Interface Descriptor */
         (8+2),            /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_CONTROL_HEADER,                 /* bDescriptorSubtype */
         0x00,          /* 1.00 */             /* bcdADC */
         0x01,
         (30+30+8+2),                                 /* wTotalLength */
         0x00,
         0x02,                                 /* bInCollection speaker+mic*/
         0x01,                                 /* baInterfaceNr1 speaker */
         0x02,                                 /* baInterfaceNr2 mic */
         /* 10 byte*/
#endif

         /*30 Byte Speakerն*/
#if 1

         /* USB Speaker Input Terminal Descriptor */
         AUDIO_INPUT_TERMINAL_DESC_SIZE,       /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_CONTROL_INPUT_TERMINAL,         /* bDescriptorSubtype */
         0x01,                                 /* bTerminalID :1*/
         0x01,                                 /* wTerminalType AUDIO_TERMINAL_USB_STREAMING   0x0101 */
         0x01,
         0x00,                                 /* bAssocTerminal */
         0x01,                                 /* bNrChannels */
         0x00,                                 /* wChannelConfig 0x0000  Mono */
         0x00,
         0x00,                                 /* iChannelNames */
         0x00,                                 /* iTerminal */
         /* 12 byte*/

         /* USB Speaker Audio Feature Unit Descriptor */
         0x09,                                 /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_CONTROL_FEATURE_UNIT,           /* bDescriptorSubtype */
         0x02,                                 /* bUnitID :2*/
         0x01,                                 /* bSourceID :1*/
         0x01,                                 /* bControlSize */
         AUDIO_CONTROL_MUTE,                   /* bmaControls(0) */
         0,                                    /* bmaControls(1) */
         0x00,                                 /* iTerminal */
         /* 09 byte */

         /* USB Speaker Output Terminal Descriptor */
         0x09,      /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_CONTROL_OUTPUT_TERMINAL,        /* bDescriptorSubtype */
         0x03,                                 /* bTerminalID :3*/
         0x01,                                 /* wTerminalType  0x0301 */
         0x03,
         0x00,                                 /* bAssocTerminal */
         0x02,                                 /* bSourceID :2*/
         0x00,                                 /* iTerminal */
         /* 09 byte */
#endif

         /*30 Byte micն*/
#if 1

         /* USB mic Input Terminal Descriptor */
         AUDIO_INPUT_TERMINAL_DESC_SIZE,       /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_CONTROL_INPUT_TERMINAL,         /* bDescriptorSubtype */
         0x04,                                 /* bTerminalID : 4*/
         0x01,                                 /* wTerminalType AUDIO_TERMINAL_USB_STREAMING   0x0201 mic*/
         0x02,
         0x00,                                 /* bAssocTerminal */
         0x01,                                 /* bNrChannels */
         0x00,                                 /* wChannelConfig 0x0000  Mono */
         0x00,
         0x00,                                 /* iChannelNames */
         0x00,                                 /* iTerminal */
         /* 12 byte*/

         /* USB mic Audio Feature Unit Descriptor */
         0x09,                                 /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_CONTROL_FEATURE_UNIT,           /* bDescriptorSubtype */
         0x05,                                 /* bUnitID :5*/
         0x04,                                 /* bSourceID :4*/
         0x01,                                 /* bControlSize */
         AUDIO_CONTROL_MUTE,                   /* bmaControls(0) */
         0,                                    /* bmaControls(1) */
         0x00,                                 /* iTerminal */
         /* 09 byte */

         /* USB mic Output Terminal Descriptor */
         0x09,      /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_CONTROL_OUTPUT_TERMINAL,        /* bDescriptorSubtype */
         0x06,                                 /* bTerminalID:6 */
         0x01,                                 /* wTerminalType  0x0101  Ƶ*/
         0x01,
         0x00,                                 /* bAssocTerminal */
         0x05,                                 /* bSourceID:5 */
         0x00,                                 /* iTerminal */
         /* 09 byte */
#endif

         /*52 Byte speaker Ƶ*/
#if 1

         /* USB Speaker Standard AS Interface Descriptor - Audio Streaming Zero Bandwidth */
         /* Interface 1, Alternate Setting 0                                              */
         AUDIO_INTERFACE_DESC_SIZE,            /* bLength */
         USB_DESC_TYPE_INTERFACE,              /* bDescriptorType */
         0x01,                                 /* bInterfaceNumber */
         0x00,                                 /* bAlternateSetting */
         0x00,                                 /* bNumEndpoints */
         USB_DEVICE_CLASS_AUDIO,               /* bInterfaceClass */
         AUDIO_SUBCLASS_AUDIOSTREAMING,        /* bInterfaceSubClass */
         AUDIO_PROTOCOL_UNDEFINED,             /* bInterfaceProtocol */
         0x00,                                 /* iInterface */
         /* 09 byte*/

         /* USB Speaker Standard AS Interface Descriptor - Audio Streaming Operational */
         /* Interface 1, Alternate Setting 1                                           */
         AUDIO_INTERFACE_DESC_SIZE,            /* bLength */
         USB_DESC_TYPE_INTERFACE,              /* bDescriptorType */
         0x01,                                 /* bInterfaceNumber */
         0x01,                                 /* bAlternateSetting */
         0x01,                                 /* bNumEndpoints */
         USB_DEVICE_CLASS_AUDIO,               /* bInterfaceClass */
         AUDIO_SUBCLASS_AUDIOSTREAMING,        /* bInterfaceSubClass */
         AUDIO_PROTOCOL_UNDEFINED,             /* bInterfaceProtocol */
         0x00,                                 /* iInterface */
         /* 09 byte*/

         /* USB Speaker Audio Streaming Interface Descriptor */
         AUDIO_STREAMING_INTERFACE_DESC_SIZE,  /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_STREAMING_GENERAL,              /* bDescriptorSubtype */
         0x01,                                 /* bTerminalLink */
         0x01,                                 /* bDelay */
         0x01,                                 /* wFormatTag AUDIO_FORMAT_PCM  0x0001 */
         0x00,
         /* 07 byte*/

         /* USB Speaker Audio Type III Format Interface Descriptor */
         0x0B,                                 /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_STREAMING_FORMAT_TYPE,          /* bDescriptorSubtype */
         AUDIO_FORMAT_TYPE_I,                  /* bFormatType */
         0x02,                                 /* bNrChannels */
         0x02,                                 /* bSubFrameSize :  2 Bytes per frame (16bits) */
         16,                                   /* bBitResolution (16-bits per sample) */
         0x01,                                 /* bSamFreqType only one frequency supported */
         AUDIO_SAMPLE_FREQ(USBD_AUDIO_FREQ),   /* Audio sampling frequency coded on 3 bytes */
         /* 11 byte*/

         /* Endpoint 1 - Standard Descriptor */
         AUDIO_STANDARD_ENDPOINT_DESC_SIZE,    /* bLength */
         USB_DESC_TYPE_ENDPOINT,               /* bDescriptorType */
         0x03,                         /* bEndpointAddress 1 out endpoint */
         USBD_EP_TYPE_ISOC,                    /* bmAttributes */
         AUDIO_PACKET_SZE(USBD_AUDIO_FREQ),    /* wMaxPacketSize in Bytes (Freq(Samples)*2(Stereo)*2(HalfWord)) */
         AUDIO_FS_BINTERVAL,                   /* bInterval */
         0x00,                                 /* bRefresh */
         0x00,                                 /* bSynchAddress */
         /* 09 byte*/

         /* Endpoint - Audio Streaming Descriptor */
         AUDIO_STREAMING_ENDPOINT_DESC_SIZE,   /* bLength */
         AUDIO_ENDPOINT_DESCRIPTOR_TYPE,       /* bDescriptorType */
         AUDIO_ENDPOINT_GENERAL,               /* bDescriptor */
         0x00,                                 /* bmAttributes */
         0x00,                                 /* bLockDelayUnits */
         0x00,                                 /* wLockDelay */
         0x00,

#endif

         /*52 Byte mic Ƶ*/
#if 1
         /* USB mic Standard AS Interface Descriptor - Audio Streaming Zero Bandwidth */
         /* Interface 1, Alternate Setting 0                                              */
         AUDIO_INTERFACE_DESC_SIZE,            /* bLength */
         USB_DESC_TYPE_INTERFACE,              /* bDescriptorType */
         0x02,                                 /* bInterfaceNumber :2*/
         0x00,                                 /* bAlternateSetting */
         0x00,                                 /* bNumEndpoints */
         USB_DEVICE_CLASS_AUDIO,               /* bInterfaceClass */
         AUDIO_SUBCLASS_AUDIOSTREAMING,        /* bInterfaceSubClass */
         AUDIO_PROTOCOL_UNDEFINED,             /* bInterfaceProtocol */
         0x00,                                 /* iInterface */
         /* 09 byte*/

         /* USB mic Standard AS Interface Descriptor - Audio Streaming Operational */
         /* Interface 1, Alternate Setting 1                                           */
         AUDIO_INTERFACE_DESC_SIZE,            /* bLength */
         USB_DESC_TYPE_INTERFACE,              /* bDescriptorType */
         0x02,                                 /* bInterfaceNumber :2*/
         0x01,                                 /* bAlternateSetting */
         0x01,                                 /* bNumEndpoints */
         USB_DEVICE_CLASS_AUDIO,               /* bInterfaceClass */
         AUDIO_SUBCLASS_AUDIOSTREAMING,        /* bInterfaceSubClass */
         AUDIO_PROTOCOL_UNDEFINED,             /* bInterfaceProtocol */
         0x00,                                 /* iInterface */
         /* 09 byte*/

         /* USB mic Audio Streaming Interface Descriptor */
         AUDIO_STREAMING_INTERFACE_DESC_SIZE,  /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_STREAMING_GENERAL,              /* bDescriptorSubtype */
         0x06,                                 /* bTerminalLink:6 micն*/
         0x01,                                 /* bDelay */
         0x01,                                 /* wFormatTag AUDIO_FORMAT_PCM  0x0001 */
         0x00,
         /* 07 byte*/

         /* USB Speaker Audio Type III Format Interface Descriptor */
         0x0B,                                 /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_STREAMING_FORMAT_TYPE,          /* bDescriptorSubtype */
         AUDIO_FORMAT_TYPE_I,                  /* bFormatType */
         0x02,                                 /* bNrChannels */
         0x02,                                 /* bSubFrameSize :  2 Bytes per frame (16bits) */
         16,                                   /* bBitResolution (16-bits per sample) */
         0x01,                                 /* bSamFreqType only one frequency supported */
         AUDIO_SAMPLE_FREQ(USBD_AUDIO_FREQ),   /* Audio sampling frequency coded on 3 bytes */
         /* 11 byte*/

         /* Endpoint 1 - Standard Descriptor */
         AUDIO_STANDARD_ENDPOINT_DESC_SIZE,    /* bLength */
         USB_DESC_TYPE_ENDPOINT,               /* bDescriptorType */
         0x83,                                 /* bEndpointAddress 1 in endpoint */
         USBD_EP_TYPE_ISOC,                    /* bmAttributes */
         AUDIO_PACKET_SZE(USBD_AUDIO_FREQ),    /* wMaxPacketSize in Bytes (Freq(Samples)*2(Stereo)*2(HalfWord)) */
         AUDIO_FS_BINTERVAL,                   /* bInterval */
         0x00,                                 /* bRefresh */
         0x00,                                 /* bSynchAddress */
         /* 09 byte*/

         /* Endpoint - Audio Streaming Descriptor */
         AUDIO_STREAMING_ENDPOINT_DESC_SIZE,   /* bLength */
         AUDIO_ENDPOINT_DESCRIPTOR_TYPE,       /* bDescriptorType */
         AUDIO_ENDPOINT_GENERAL,               /* bDescriptor */
         0x00,                                 /* bmAttributes */
         0x00,                                 /* bLockDelayUnits */
         0x00,                                 /* wLockDelay */
         0x00,

#endif

};

#if 1
/* Language Descriptor */
const UINT8  MyLangDescrHD[] =
{
    0x04, 0x03, 0x09, 0x04
};

/* Manufactor Descriptor */
const UINT8  MyManuInfoHD[] =
{
    0x0E, 0x03, 'w', 0, 'c', 0, 'h', 0, '.', 0, 'c', 0, 'n', 0
};

/* Product Information */
const UINT8  MyProdInfoHD[] =
{
    0x0C, 0x03, 'C', 0, 'H', 0, '1', 0, '0', 0, 'x', 0
};

/* USBкַ */
const UINT8  MySerNumInfoHD[ ] =
{
    /* 0123456789 */
    22,03,48,0,49,0,50,0,51,0,52,0,53,0,54,0,55,0,56,0,57,0
};

/* USB豸޶ */
const UINT8 MyUSBQUADescHD[ ] =
{
    0x0A, 0x06, 0x00, 0x02, 0xFF, 0x00, 0xFF, 0x40, 0x01, 0x00,
};
#endif

void OTG_FS_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

/*********************************************************************
 * @fn      USBOTG_FS_DeviceInit
 *
 * @brief   Initializes USB device.
 *
 * @return  none
 */
void USBDeviceInit( void )
{
    pbuf=buf;
    pbuf_head=buf;
    pbuf_tail=buf;
    USBOTG_FS->BASE_CTRL = 0x00;

    USBOTG_FS->UEP2_3_MOD =USBHD_UEP3_RX_EN|USBHD_UEP3_TX_EN|USBHD_UEP3_BUF_MOD;//128+128

    USBOTG_FS->UEP0_DMA = (UINT32)pEP0_RAM_Addr;
    USBOTG_FS->UEP3_DMA = (UINT32)pEP3_RAM_Addr;
    USBOTG_FS->UEP0_RX_CTRL = USBHD_UEP_R_RES_ACK;
    USBOTG_FS->UEP3_RX_CTRL = USBHD_UEP_R_RES_TOUT|DATA(0);

    USBOTG_FS->UEP0_TX_CTRL = USBHD_UEP_T_RES_NAK;
    USBOTG_FS->UEP3_TX_LEN = DEF_USBD_SYC_PACK_SIZE;
    USBOTG_FS->UEP3_TX_CTRL = USBHD_UEP_T_RES_TOUT|DATA(0);


    USBOTG_FS->INT_FG   = 0xFF;
    USBOTG_FS->INT_EN   = USBHD_UIE_SUSPEND | USBHD_UIE_BUS_RST | USBHD_UIE_TRANSFER;
    USBOTG_FS->DEV_ADDR = 0x00;
#if 0
    *(UINT8 *)( pEP1_IN_DataBuf + 0 ) = (UINT8)( 0 >> 24 );
    *(UINT8 *)( pEP1_IN_DataBuf + 1 ) = (UINT8)( 0 >> 16 );
    *(UINT8 *)( pEP1_IN_DataBuf + 2 ) = (UINT8)( 0 >> 8 );
    *(UINT8 *)( pEP1_IN_DataBuf + 3 ) = (UINT8)( 0 );

    R8_USB_CTRL = RB_UC_DEV_PU_EN | RB_UC_INT_BUSY | RB_UC_DMA_EN | RB_UC_LOW_SPEED;
    R8_UDEV_CTRL = RB_UD_PD_DIS|RB_UD_PORT_EN|RB_UD_LOW_SPEED;
#else
    USBOTG_FS->BASE_CTRL = USBHD_UC_DEV_PU_EN | USBHD_UC_INT_BUSY | USBHD_UC_DMA_EN;
    USBOTG_FS->UDEV_CTRL = USBHD_UD_PD_DIS|USBHD_UD_PORT_EN;
#endif

}

/*********************************************************************
 * @fn      USBOTG_RCC_Init
 *
 * @brief   Initializes the usbotg clock configuration.
 *
 * @return  none
 */
void USBOTG_RCC_Init( void )
{
    pbuf=buf;
#ifdef CH32V30x_D8C
    RCC_USBCLK48MConfig( RCC_USBCLK48MCLKSource_USBPHY );
    RCC_USBHSPLLCLKConfig( RCC_HSBHSPLLCLKSource_HSE );
    RCC_USBHSConfig( RCC_USBPLL_Div2 );
    RCC_USBHSPLLCKREFCLKConfig( RCC_USBHSPLLCKREFCLK_4M );
    RCC_USBHSPHYPLLALIVEcmd( ENABLE );
    RCC_AHBPeriphClockCmd( RCC_AHBPeriph_USBHS, ENABLE );

#else
    RCC_OTGFSCLKConfig(RCC_OTGFSCLKSource_PLLCLK_Div1);;

#endif

    RCC_AHBPeriphClockCmd( RCC_AHBPeriph_OTG_FS, ENABLE );
}

/*********************************************************************
 * @fn      USBOTG_Init
 *
 * @brief   Initializes the USBOTG full speed device.
 *
 * @return  none
 */
void USBOTG_Init( void )
{
    /* ˵㻺ʼ */
    pEP0_RAM_Addr = EP0_DatabufHD;
    pEP3_RAM_Addr = EP3_DatabufHD;


    /* ʹusbʱ */
    USBOTG_RCC_Init( );
    Delay_Us(100);
    /* usb豸ʼ */
    USBDeviceInit( );
    EXTEN->EXTEN_CTR |= EXTEN_USBD_PU_EN;
    /* ʹusbж */
    NVIC_EnableIRQ( OTG_FS_IRQn );
}

/*********************************************************************
 * @fn      OTG_FS_IRQHandler
 *
 * @brief   This function handles OTG_FS exception.
 *
 * @return  none
 */
extern u8 data[1023];
extern u8 Flag_KEY;
u16 time_data_size=0;
void OTG_FS_IRQHandler( void )
{
    u16  len,len2,chtype;
    UINT8  intflag, errflag = 0;
    intflag = USBOTG_FS->INT_FG;

    if( intflag & USBHD_UIF_TRANSFER )
    {
        switch ( USBOTG_FS->INT_ST & USBHD_UIS_TOKEN_MASK )
        {
            /* SETUP */
            case USBHD_UIS_TOKEN_SETUP:
#if 0
                /* ӡǰUsbsetup  */
                printf( "Setup Req :\n" );
                printf( "%02X ", pSetupReqPakHD->bRequestType );
                printf( "%02X ", pSetupReqPakHD->bRequest );
                printf( "%04X ", pSetupReqPakHD->wValue );
                printf( "%04X ", pSetupReqPakHD->wIndex );
                printf( "%04X ", pSetupReqPakHD->wLength );
                printf( "\n" );

#endif
                USBOTG_FS->UEP0_TX_CTRL = USBHD_UEP_T_TOG|USBHD_UEP_T_RES_NAK;
                USBOTG_FS->UEP0_RX_CTRL = USBHD_UEP_R_TOG|USBHD_UEP_R_RES_ACK;
                SetupReqLen  = pSetupReqPakHD->wLength;
                SetupReqCode = pSetupReqPakHD->bRequest;
                chtype = pSetupReqPakHD->bRequestType;
                len = 0;
                errflag = 0;
                /* жϵǰǱ׼ */
                if ( ( pSetupReqPakHD->bRequestType & USB_REQ_TYP_MASK ) != USB_REQ_TYP_STANDARD )
                {
                    /* ,, */
                    if( pSetupReqPakHD->bRequestType & 0x40 )
                    {
                        /*  */
                        switch( pSetupReqPakHD->bRequest )
                        {
                            default:
                                errflag = 0xFF;/* ʧ */
                                break;
                        }
                    }
                    else if(pSetupReqPakHD->bRequestType == 0xa1)
                    {
                        switch( pSetupReqPakHD->bRequest )
                        {
                        case 0x81://GET CUR
                            if((pSetupReqPakHD->wIndex==0x200)||(pSetupReqPakHD->wIndex==0x500))//Feature Unit
                            {
                                if(pSetupReqPakHD->wValue==0x100)//mute
                                {
                                    u8 class_request[1]={0x00};
                                    pDescr=class_request;
                                    len=1;
                                }
                                if(pSetupReqPakHD->wValue==0x200)//mute
                                {
                                    u8 class_request[2]={0x00,0xf9};
                                    pDescr=class_request;
                                    len=2;
                                }
                            }
                            break;
                        case 0x82://GET MIN
                            break;
                        case 0x83://GET MAX
                            break;
                        case 0x84://GET RES
                            break;
                        default:
                            errflag = 0xFF;
                            break;
                        }
                    }
                    else if( pSetupReqPakHD->bRequestType & 0x20 )
                    {
                        /* HID */
                        switch( pSetupReqPakHD->bRequest )
                        {
                        case 0x01: //GetReport
                            break;
                        case 0x02: //GetIdle
                            break;
                        case 0x03: //GetProtocol
                            break;
                        case 0x09: //SetReport
                            break;
                        case 0x0A: //SetIdle
                            break;
                        case 0x0B: //SetProtocol
                            break;

                        default:
                            errflag = 0xFF;
                            break;
                        }
                    }

                    /* жǷ */
                    if( errflag != 0xFF )
                    {
                        if( SetupReqLen>len )   SetupReqLen = len;
                        len = (SetupReqLen >= DEF_USBD_UEP0_SIZE) ? DEF_USBD_UEP0_SIZE : SetupReqLen;
                        memcpy( pEP0_DataBuf, pDescr, len );
                        pDescr += len;

                    }
                }
                else
                {
                    /* ׼USB */
                    switch( SetupReqCode )
                    {
                        case USB_GET_DESCRIPTOR:
                        {
                            switch( ((pSetupReqPakHD->wValue)>>8) )
                            {
                                case USB_DESCR_TYP_DEVICE:
                                    /* ȡ豸 */
                                    pDescr = MyDevDescrHD;
                                    len = MyDevDescrHD[0];
                                    break;

                                case USB_DESCR_TYP_CONFIG:
                                    /* ȡ */
#if DEF_USBD_SPEED == DEF_USBD_SPEED_FULL
                                    pDescr = MyCfgDescr_FS;
                                    len = sizeof( MyCfgDescr_FS );
#elif DEF_USBD_SPEED == DEF_USBD_SPEED_LOW
                                    pDescr = MyCfgDescr_LS;
                                    len = sizeof( MyCfgDescr_LS );
#endif
                                    break;

                                case USB_DESCR_TYP_STRING:
                                    /* ȡַ */
                                    switch( (pSetupReqPakHD->wValue)&0xff )
                                    {
                                        case 0:
                                            /* ַ */
                                            pDescr = MyLangDescrHD;
                                            len = MyLangDescrHD[0];
                                            break;

                                        case 1:
                                            /* USBַ */
                                            pDescr = MyManuInfoHD;
                                            len = MyManuInfoHD[0];
                                            break;

                                        case 2:
                                            /* USBƷַ */
                                            pDescr = MyProdInfoHD;
                                            len = MyProdInfoHD[0];
                                            break;

                                        case 3:
                                            /* USBкַ */
                                            pDescr = MySerNumInfoHD;
                                            len = sizeof( MySerNumInfoHD );
                                            break;

                                        default:
                                            errflag = 0xFF;
                                            break;
                                    }
                                    break;

                                case USB_DESCR_TYP_REPORT:
                                    /* USB豸 */
                                    if( (UINT8)((pSetupReqPakHD->wIndex)&0xFF) == 0 )
                                    {

                                    }
                                    else if( (UINT8)((pSetupReqPakHD->wIndex)&0xFF) == 1 )
                                    {

                                    }
                                    else
                                    {
                                        errflag = 0xFF;
                                    }
                                    break;

                                case USB_DESCR_TYP_QUALIF:
                                    /* 豸޶ */
                                    pDescr = ( PUINT8 )&MyUSBQUADescHD[ 0 ];
                                    len = sizeof( MyUSBQUADescHD );
                                    break;

                                case USB_DESCR_TYP_SPEED:
                                    /* ٶ */
                                    errflag = 0xFF;
                                    break;

                                case USB_DESCR_TYP_BOS:
                                    /* BOS */
                                    /* USB2.0豸֧BOS */
                                    errflag = 0xFF;
                                    break;

                                default :
                                    errflag = 0xff;
                                    break;

                            }

                            if( SetupReqLen>len )   SetupReqLen = len;
                            len = (SetupReqLen >= DEF_USBD_UEP0_SIZE) ? DEF_USBD_UEP0_SIZE : SetupReqLen;
                            memcpy( pEP0_DataBuf, pDescr, len );
                            pDescr += len;
                        }
                            break;

                        case USB_SET_ADDRESS:
                            /* õַ */
                            SetupReqLen = (pSetupReqPakHD->wValue)&0xff;
                            break;

                        case USB_GET_CONFIGURATION:
                            /* ȡֵ */
                            pEP0_DataBuf[0] = DevConfig;
                            if ( SetupReqLen > 1 ) SetupReqLen = 1;
                            break;

                        case USB_SET_CONFIGURATION:
                            /* ֵ */
                            DevConfig = (pSetupReqPakHD->wValue)&0xff;
                            break;

                        case USB_CLEAR_FEATURE:
                            /*  */
                            if ( ( pSetupReqPakHD->bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_ENDP )
                            {
                                /* ˵ */
                                switch( (pSetupReqPakHD->wIndex)&0xff )
                                {
                                case 0x83:
                                    USBOTG_FS->UEP3_TX_CTRL = (USBOTG_FS->UEP3_TX_CTRL & ~( USBHD_UEP_T_TOG|USBHD_UEP_T_RES_MASK )) | USBHD_UEP_T_RES_NAK;
                                    break;

                                case 0x03:
                                    USBOTG_FS->UEP3_RX_CTRL = (USBOTG_FS->UEP3_RX_CTRL & ~( USBHD_UEP_R_TOG|USBHD_UEP_R_RES_MASK )) | USBHD_UEP_R_RES_ACK;
                                    break;


                                default:
                                    errflag = 0xFF;
                                    break;

                                }
                            }
                            else    errflag = 0xFF;
                            break;

                        case USB_SET_FEATURE:
                            /*  */
                            if( ( pMySetupReqPakHD->bRequestType & 0x1F ) == 0x00 )
                            {
                                /* 豸 */
                                if( pMySetupReqPakHD->wValue == 0x01 )
                                {
                                    if( MyCfgDescr_FS[ 7 ] & 0x20 )
                                    {
                                        /* ûʹܱ־ */
                                        USBHD_Dev_SleepStatus = 0x01;
                                    }
                                    else
                                    {
                                        errflag = 0xFF;
                                    }
                                }
                                else
                                {
                                    errflag = 0xFF;
                                }
                            }
                            else if( ( pMySetupReqPakHD->bRequestType & 0x1F ) == 0x02 )
                            {
                                /* ö˵ */
                                if( pMySetupReqPakHD->wValue == 0x00 )
                                {
                                    /* ָ˵STALL */
                                    switch( ( pMySetupReqPakHD->wIndex ) & 0xff )
                                    {
                                        case 0x83:
                                            /* ö˵3 IN STALL */
                                            USBOTG_FS->UEP3_TX_CTRL = ( USBOTG_FS->UEP3_TX_CTRL &= ~USBHD_UEP_T_RES_MASK ) | USBHD_UEP_T_RES_STALL;
                                            //USBHS->UEP3_CTRL  = ( USBHS->UEP3_CTRL & ~USBHS_EP_T_RES_MASK ) | USBHS_EP_T_RES_STALL;
                                            break;

                                        case 0x03:
                                            /* ö˵3 OUT Stall */
                                            USBOTG_FS->UEP3_RX_CTRL = ( USBOTG_FS->UEP3_RX_CTRL &= ~USBHD_UEP_R_RES_MASK ) | USBHD_UEP_R_RES_STALL;
                                            //USBHS->UEP3_CTRL  = ( USBHS->UEP3_CTRL & ~USBHS_EP_R_RES_MASK ) | USBHS_EP_R_RES_STALL;
                                            break;


                                        default:
                                            errflag = 0xFF;
                                            break;
                                    }
                                }
                                else
                                {
                                    errflag = 0xFF;
                                }
                            }
                            else
                            {
                                errflag = 0xFF;
                            }
                            break;

                        case USB_GET_INTERFACE:
                            /* ȡӿ */
                            pEP0_DataBuf[0] = 0x00;
                            if ( SetupReqLen > 1 ) SetupReqLen = 1;
                            break;

                        case USB_SET_INTERFACE:
                            /* ýӿ */
                            if(pSetupReqPakHD->wIndex==0x01)//Speaker
                            {
                                if(pSetupReqPakHD->wValue==1)
                                {
                                    USBOTG_FS->UEP3_RX_CTRL =USBHD_UEP_R_RES_TOUT|DATA(0);
                                }
                                else
                                {
                                    USBOTG_FS->UEP3_RX_CTRL =USBHD_UEP_R_RES_NAK;
                                }

                            }
                            if(pSetupReqPakHD->wIndex==0x02)//mic
                            {
                                if(pSetupReqPakHD->wValue==1)
                                {
                                    USBOTG_FS->UEP3_TX_CTRL = USBHD_UEP_T_RES_TOUT|DATA(0);
                                    USBOTG_FS->UEP3_TX_LEN  = 0;
                                }
                                else
                                {
                                    USBOTG_FS->UEP3_TX_CTRL = USBHD_UEP_T_RES_NAK;
                                }

                            }


                            break;

                        case USB_GET_STATUS:
                            /* ݵǰ˵ʵ״̬Ӧ */
                            EP0_DatabufHD[ 0 ] = 0x00;
                            EP0_DatabufHD[ 1 ] = 0x00;
                            if( pMySetupReqPakHD->wIndex == 0x83 )
                            {
                                if( ( USBOTG_FS->UEP3_TX_CTRL & USBHD_UEP_T_RES_MASK ) == USBHD_UEP_T_RES_STALL )
                                {
                                    EP0_DatabufHD[ 0 ] = 0x01;
                                }
                            }
                            else if( pMySetupReqPakHD->wIndex == 0x03 )
                            {
                                if( ( USBOTG_FS->UEP3_RX_CTRL & USBHD_UEP_R_RES_MASK ) == USBHD_UEP_R_RES_STALL )
                                {
                                    EP0_DatabufHD[ 0 ] = 0x01;
                                }
                            }
                            if( USBHD_Dev_SetupReqLen > 2 )
                            {
                                USBHD_Dev_SetupReqLen = 2;
                            }
                            break;

                        default:
                            errflag = 0xff;
                            break;
                    }
                }
                if( errflag == 0xff)
                {
#if 0
                    printf("uep0 stall\n");
#endif
                    USBOTG_FS->UEP0_TX_CTRL = USBHD_UEP_T_TOG|USBHD_UEP_T_RES_STALL;
                    USBOTG_FS->UEP0_RX_CTRL = USBHD_UEP_R_TOG|USBHD_UEP_R_RES_STALL;
                }
                else
                {
                    if( chtype & 0x80 )
                    {
                        len = (SetupReqLen>DEF_USBD_UEP0_SIZE) ? DEF_USBD_UEP0_SIZE : SetupReqLen;
                        SetupReqLen -= len;
                    }
                    else  len = 0;

                    USBOTG_FS->UEP0_TX_LEN  = len;
                    USBOTG_FS->UEP0_TX_CTRL = USBHD_UEP_T_TOG|USBHD_UEP_T_RES_ACK;
                    USBOTG_FS->UEP0_RX_CTRL = USBHD_UEP_R_TOG|USBHD_UEP_R_RES_ACK;
                }
                break;

            case USBHD_UIS_TOKEN_IN:
                switch ( USBOTG_FS->INT_ST & ( USBHD_UIS_TOKEN_MASK | USBHD_UIS_ENDP_MASK ) )
                {
                    case USBHD_UIS_TOKEN_IN:
                        switch( SetupReqCode )
                        {
                            case USB_GET_DESCRIPTOR:
                                    len = SetupReqLen >= DEF_USBD_UEP0_SIZE ? DEF_USBD_UEP0_SIZE : SetupReqLen;
                                    memcpy( pEP0_DataBuf, pDescr, len );
                                    SetupReqLen -= len;
                                    pDescr += len;
                                    USBOTG_FS->UEP0_TX_LEN   = len;
                                    USBOTG_FS->UEP0_TX_CTRL ^= USBHD_UEP_T_TOG;
                                    break;

                            case USB_SET_ADDRESS:
                                    USBOTG_FS->DEV_ADDR = (USBOTG_FS->DEV_ADDR&USBHD_UDA_GP_BIT) | SetupReqLen;
                                    USBOTG_FS->UEP0_TX_CTRL = USBHD_UEP_T_RES_NAK;
                                    USBOTG_FS->UEP0_RX_CTRL = USBHD_UEP_R_RES_ACK;
                                    break;

                            default:
                                    USBOTG_FS->UEP0_TX_LEN = 0;
                                    USBOTG_FS->UEP0_TX_CTRL = USBHD_UEP_T_RES_NAK;
                                    USBOTG_FS->UEP0_RX_CTRL = USBHD_UEP_R_RES_ACK;
                                    break;

                        }
                        break;

                case USBHD_UIS_TOKEN_IN | 3:

                if(Flag_KEY==1)
                {
#if CHANGE_DMA_ADDR    //dataǷͻַ

    #if 0               //ֱ޸dataеֵ
                    data[0]++;


    #else               //dataһܴ飬Ҳֱ޸DMAַ,
                    time_data_size++;// ﵽdataҪͷʼֹͣ
                    USBOTG_FS->UEP3_DMA = (u32)data+time_data_size*PACK_SIZE;
                    if(time_data_size>=8)//dataС
                    {
                        time_data_size=0;
                        USBOTG_FS->UEP3_DMA=(u32)data-128;//ͷʼ
                    }
    #endif


#else               //û䣬data뻺
                    data[0]++;
                    memcpy( pEP3_IN_DataBuf, data, PACK_SIZE );
#endif
                    USBOTG_FS->UEP3_TX_CTRL =USBHD_UEP_T_RES_TOUT|DATA(0);
                    USBOTG_FS->UEP3_TX_LEN   = PACK_SIZE;
                }
                else
                {
                    if(buf_value>=EP3_RX_len)//
                    {
                            memcpy( pEP3_IN_DataBuf, pbuf_head, EP3_RX_len );
                            pbuf_head+=EP3_RX_len;
                            if(pbuf_head>=(buf+buf_size))
                            {
                                pbuf_head=buf;
                            }
                            USBOTG_FS->UEP3_TX_CTRL =USBHD_UEP_T_RES_TOUT|DATA(0);
                            USBOTG_FS->UEP3_TX_LEN   = EP3_RX_len;
                            buf_value-=EP3_RX_len;
                    }
                    else
                    {
                        USBOTG_FS->UEP3_TX_CTRL = USBHD_UEP_T_RES_TOUT|DATA(0);
                        USBOTG_FS->UEP3_TX_LEN   = 0;
                    }
                }

                    break;
                default :
                    break;

                }
                break;

            case USBHD_UIS_TOKEN_OUT:
                switch ( USBOTG_FS->INT_ST & ( USBHD_UIS_TOKEN_MASK | USBHD_UIS_ENDP_MASK ) )
                {
                    case USBHD_UIS_TOKEN_OUT:
                            break;

                    case USBHD_UIS_TOKEN_OUT | 3:
                    //յݷŵλ
                            len = USBOTG_FS->RX_LEN;
                            EP3_RX_len= USBOTG_FS->RX_LEN;
                            len2=buf+buf_size-pbuf_tail;//ʣռ
                            if(len2<len)//
                            {
                                memcpy( pbuf_tail, pEP3_OUT_DataBuf, len2 );
                                pbuf_tail=buf;
                                memcpy( pbuf_tail, pEP3_OUT_DataBuf, len-len2 );
                                pbuf_tail=pbuf_tail+len-len2;
                                buf_value+=len;
                            }
                            else
                            {
                                memcpy( pbuf_tail, pEP3_OUT_DataBuf, len );
                                pbuf_tail+=len;
                                buf_value+=len;
                            }


                        break;
                    default:
                        break;
                }

                break;

            case USBHD_UIS_TOKEN_SOF:

                break;

            default :
                break;

        }

        USBOTG_FS->INT_FG = USBHD_UIF_TRANSFER;
    }
    else if( intflag & USBHD_UIF_BUS_RST )
    {
        USBOTG_FS->DEV_ADDR = 0;

        USBOTG_FS->UEP0_RX_CTRL = USBHD_UEP_R_RES_ACK;
        USBOTG_FS->UEP3_RX_CTRL = USBHD_UEP_R_RES_TOUT|DATA(0);

        USBOTG_FS->UEP0_TX_CTRL = USBHD_UEP_T_RES_NAK;
        USBOTG_FS->UEP3_TX_CTRL = USBHD_UEP_T_RES_TOUT|DATA(0);


        USBOTG_FS->INT_FG |= USBHD_UIF_BUS_RST;
    }
    else if( intflag & USBHD_UIF_SUSPEND )
    {
        if ( USBOTG_FS->MIS_ST & USBHD_UMS_SUSPEND ) {;}
        else{;}
        USBOTG_FS->INT_FG = USBHD_UIF_SUSPEND;
    }
    else
    {
        USBOTG_FS->INT_FG = intflag;
    }
}


