/********************************** (C) COPYRIGHT *******************************
* File Name          : ch32v30x_usbhs_device.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/06/06
* Description        : USBٲļ
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/
#include "ch32v30x_usbhs_device.h"

#define LOOP_TEST 1
/******************************************************************************/
/*  */

/*  */
void USBHS_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

/* USB */
__attribute__ ((aligned(4))) UINT8 EP0_Databuf[ DEF_USBD_UEP0_SIZE ]; /* ˵0շ */

#define pMySetupReqPak        ((PUSB_SETUP_REQ)EP0_Databuf)/*SETUP*/

const UINT8 *pDescr;
volatile UINT8  USBHS_Dev_SetupReqCode = 0xFF;                                  /* USB2.0豸Setup */
volatile UINT16 USBHS_Dev_SetupReqLen = 0x00;                                   /* USB2.0豸Setup */
volatile UINT8  USBHS_Dev_SetupReqValueH = 0x00;                                /* USB2.0豸SetupValueֽ */
volatile UINT8  USBHS_Dev_Config = 0x00;                                        /* USB2.0豸ֵ */
volatile UINT8  USBHS_Dev_Address = 0x00;                                       /* USB2.0豸ֵַ */
volatile UINT8  USBHS_Dev_SleepStatus = 0x00;                                   /* USB2.0豸˯״̬ */
volatile UINT8  USBHS_Dev_EnumStatus = 0x00;                                    /* USB2.0豸ö״̬ */
volatile UINT8  USBHS_Dev_Endp0_Tog = 0x01;                                     /* USB2.0豸˵0ͬ־ */
volatile UINT8  USBHS_Dev_Speed = 0x01;                                         /* USB2.0豸ٶ */
volatile UINT8  USBHS_Int_Flag  = 0x00;                                         /* USB2.0豸жϱ־ */


#if LOOP_TEST   //  EP3ܵݻشһͬһ
u8 * pEP3BUF_RX;
u8 * pEP3BUF_TX;

__attribute__ ((aligned(4))) UINT8 EP3_Rx_Databuf[ RX_Buf_size ]; /* ˵3ݽջ */

#else
#define buf_size 1024*20
u8 buf[buf_size]={0};//λ
u8 * pbuf;
u8 * pbuf_rx;
u8 * pbuf_tx;

__attribute__ ((aligned(4))) UINT8 EP3_Rx_Databuf[ DEF_USBD_SYC_PACK_SIZE ]; /* ˵3ݽջ */
__attribute__ ((aligned(4))) UINT8 EP3_Tx_Databuf[ DEF_USBD_SYC_PACK_SIZE ]; /* ˵3ݷͻ */

#endif


u8 buf_1024[1024*10]={0};
u16 buf_value=0;
u8 ready_flag,pvalue=0;
u16 EP3_RX_len=0;

/******************************************************************************/
/* USB豸 */
UINT8  MyDevDescr[ ] =
{
    0x12, 0x01, 0x00, 0x02, 0x00, 0x00, 0x00, 0x40,
    0x86, 0x1A, 0xE1, 0xE6,
    DEF_IC_PRG_VER2, DEF_IC_PRG_VER, 0x01, 0x02, 0x00, 0x01
};

/* USB() */
UINT8  MyCfgDescr_LS[ ] =
{

};



UINT8  MyCfgDescr_HS[ ] =
{
#if 1
#if 1     //HS audio 
          //
          0x09,                                 /* bLength */
          USB_DESC_TYPE_CONFIGURATION,    /* bDescriptorType */
          LOBYTE(0xF7),HIBYTE(0xF7),            /* wTotalLength иĶʱע޸*/
          0x03,                                 /* bNumInterfaces иĶʱע޸*/
          0x01,                                 /* bConfigurationValue */
          0x00,                                 /* iConfiguration */
          0xC0,                                 /* bmAttributes BUS Powered*/
          0x32,                                 /* bMaxPower = 100 mA*/
          /* 09 byte*/
#endif

#if 1
          //Standard Interface Association Descriptor
          AUDIO_INTERFACE_ASSOCIATION_DESC_SIZE,
          0x0B,                          /*Standard Interface Association Descriptor*/
          0x00,                          /*bFirstInterface*/
          0x03,                          /*bInterfaceCountиĶʱע޸*/
          0x01,                          /*bFunctionClass*/
          0x00,                          /*bFunctionSubClass*/
          AUDIO_IP_VERSION_02_00,        /*bFunctionProtocol*/
          0x00,                          /*iFunction*/
          /* 08 byte */

          /* Standard AC Interface Descriptor */
          AUDIO_INTERFACE_DESC_SIZE,            /* bLength */
          USB_INTERFACE_DESCRIPTOR_TYPE,        /* bDescriptorType */
          0x00,                                 /* bInterfaceNumber */
          0x00,                                 /* bAlternateSetting */
          0x00,                                 /* bNumEndpoints */
          USB_DEVICE_CLASS_AUDIO,               /* bInterfaceClass */
          AUDIO_SUBCLASS_AUDIOCONTROL,          /* bInterfaceSubClass */
          AUDIO_IP_VERSION_02_00,               /* bInterfaceProtocol */
          0x00,                                 /* iInterface */
          /* 09 byte*/

          /* Class-specific AC Interface Descriptor */
          AUDIO_INTERFACE_DESC_SIZE,            /* bLength */
          AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
          AUDIO_CONTROL_HEADER,                 /* bDescriptorSubtype */
          0x00,                                 /* bcdADC */
          0x02,                                 /* 2.00 */
          0x01,                                 /* bCategory */
          (47+47+AUDIO_20_CLK_SOURCE_DESC_SIZE+AUDIO_INTERFACE_DESC_SIZE),  /* wTotalLength */
          0x00,
          0x00,                                 /* bmControls */
          /* 09 byte*/
#endif

#if 1
          /* USB Speaker Clock Source Descriptor */
          AUDIO_20_CLK_SOURCE_DESC_SIZE,        /* bLength */
          AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
          AUDIO_CONTROL_CLOCK_SOURCE,           /* bDescriptorSubtype */
          AUDIO_CLOCK_ID,                       /* bClockID */
          0x03,                                 /* bmAttributes */
          0x07,                                 /* bmControls TODO */
          0x00,                                 /* bAssocTerminal */
          0x00,                                 /* iClockSource */
          /* 08 byte*/
#endif

#if 1       //HeadSet ն  47
          /* USB HeadSet Input Terminal Descriptor */
          AUDIO_20_IT_DESC_SIZE,                /* bLength */
          AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
          AUDIO_CONTROL_INPUT_TERMINAL,         /* bDescriptorSubtype */
          AUDIO_HEADSET_IN_TERMINAL_ID,                          /* bTerminalID */
          0x01,                                 /* wTerminalType AUDIO_TERMINAL_USB_STREAMING   0x0101 */
          0x01,
          0x00,                                 /* bAssocTerminal */
          AUDIO_CLOCK_ID,                       /* bCSourceID*/
          0x02,                                 /* bNrChannels */
          0x03,                                 /* wChannelConfig 0x00000003  Stereo */
          0x00,
          0x00,
          0x00,
          0x00,                                 /* iChannelNames */
          0x00,                                 /* bmControls */
          0x00,
          0x00,                                 /* iTerminal */
          /* 17 byte*/

          /* USB HeadSet Audio Feature Unit Descriptor */
          0x12,                                 /* bLength */
          AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
          AUDIO_CONTROL_FEATURE_UNIT,           /* bDescriptorSubtype */
          AUDIO_HEADSET_FEATURE_UNIT_ID,                          /* bUnitID */
          AUDIO_HEADSET_IN_TERMINAL_ID,                          /* bSourceID */
          AUDIO_20_CTL_MUTE(CONTROL_BITMAP_PROG)/* bmaControls(0) */
          | AUDIO_20_CTL_VOLUME(CONTROL_BITMAP_PROG),
          0x00,
          0x00,
          0x00,
          0x00,                                 /* bmaControls(1) */
          0x00,
          0x00,
          0x00,
          0x00,                                 /* bmaControls(2) */
          0x00,
          0x00,
          0x00,
          0x00,                                 /* iFeature */
          /* 18 byte*/

          /*USB HeadSet Output Terminal Descriptor */
          AUDIO_20_OT_DESC_SIZE,                /* bLength */
          AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
          AUDIO_CONTROL_OUTPUT_TERMINAL,        /* bDescriptorSubtype */
          AUDIO_HEADSET_OUT_TERMINAL_ID,        /* bTerminalID */
          0x02,                                 /* wTerminalType  0x0302: Headphone*/
          0x03,
          0x00,                                 /* bAssocTerminal */
          AUDIO_HEADSET_FEATURE_UNIT_ID,        /* bSourceID */
          AUDIO_CLOCK_ID,                       /* bCSourceID */
          0x00,                                 /* bmControls */
          0x00,
          0x00,                                 /* iTerminal */
          /* 12 byte*/
#endif

#if 1       //mic ն  47
          /* USB mic Input Terminal Descriptor */
          AUDIO_20_IT_DESC_SIZE,                /* bLength */
          AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
          AUDIO_CONTROL_INPUT_TERMINAL,         /* bDescriptorSubtype */
          AUDIO_MICPHONE_IN_TERMINAL_ID,        /* bTerminalID */
          0x01,                                 /* wTerminalType AUDIO_TERMINAL_USB_STREAMING */
          0x02,                                 /*0201-mic*/
          0x00,                                 /* bAssocTerminal */
          AUDIO_CLOCK_ID,                       /* bCSourceID*/
          0x02,                                 /* bNrChannels */
          0x03,                                 /* wChannelConfig 0x00000003  Stereo */
          0x00,
          0x00,
          0x00,
          0x00,                                 /* iChannelNames */
          0x00,                                 /* bmControls */
          0x00,
          0x00,                                 /* iTerminal */
          /* 17 byte*/

          /* USB HeadSet Audio Feature Unit Descriptor */
          0x12,                                 /* bLength */
          AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
          AUDIO_CONTROL_FEATURE_UNIT,           /* bDescriptorSubtype */
          AUDIO_MICPHONE_FEATURE_UNIT_ID,       /* bUnitID */
          AUDIO_MICPHONE_IN_TERMINAL_ID,        /* bSourceID */
          AUDIO_20_CTL_MUTE(CONTROL_BITMAP_PROG)/* bmaControls(0) */
          | AUDIO_20_CTL_VOLUME(CONTROL_BITMAP_PROG),
          0x00,
          0x00,
          0x00,
          0x00,                                 /* bmaControls(1) */
          0x00,
          0x00,
          0x00,
          0x00,                                 /* bmaControls(2) */
          0x00,
          0x00,
          0x00,
          0x00,                                 /* iFeature */
          /* 18 byte*/

          /*USB HeadSet Output Terminal Descriptor */
          AUDIO_20_OT_DESC_SIZE,                /* bLength */
          AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
          AUDIO_CONTROL_OUTPUT_TERMINAL,        /* bDescriptorSubtype */
          AUDIO_MICPHONE_OUT_TERMINAL_ID,       /* bTerminalID */
          0x01,                                 /* wTerminalType 0101-Ƶ*/
          0x01,
          0x00,                                 /* bAssocTerminal */
          AUDIO_MICPHONE_FEATURE_UNIT_ID,       /* bSourceID */
          AUDIO_CLOCK_ID,                       /* bCSourceID */
          0x00,                                 /* bmControls */
          0x00,
          0x00,                                 /* iTerminal */
          /* 12 byte*/
#endif

#if 1     //HeadSet Ƶ 55
          /* USB HeadSet Standard AS Interface Descriptor - Audio Streaming Zero Bandwidth */
          /* Interface 1, Alternate Setting 0                                              */
          AUDIO_INTERFACE_DESC_SIZE,            /* bLength */
          USB_INTERFACE_DESCRIPTOR_TYPE,        /* bDescriptorType */
          0x01,                                 /* bInterfaceNumber */
          0x00,                                 /* bAlternateSetting */
          0x00,                                 /* bNumEndpoints */
          USB_DEVICE_CLASS_AUDIO,               /* bInterfaceClass */
          AUDIO_SUBCLASS_AUDIOSTREAMING,        /* bInterfaceSubClass */
          AUDIO_IP_VERSION_02_00,               /* bInterfaceProtocol */
          0x00,                                 /* iInterface */
          /* 09 byte*/

          /* USB Speaker Standard AS Interface Descriptor - Audio Streaming Operational */
          /* Interface 1, Alternate Setting 1                                           */
          AUDIO_INTERFACE_DESC_SIZE,            /* bLength */
          USB_INTERFACE_DESCRIPTOR_TYPE,        /* bDescriptorType */
          0x01,                                 /* bInterfaceNumber */
          0x01,                                 /* bAlternateSetting */
          0x01,                                 /* bNumEndpoints */
          USB_DEVICE_CLASS_AUDIO,               /* bInterfaceClass */
          AUDIO_SUBCLASS_AUDIOSTREAMING,        /* bInterfaceSubClass */
          AUDIO_IP_VERSION_02_00,               /* bInterfaceProtocol */
          0x00,                                 /* iInterface */
          /* 09 byte*/

          /* USB HeadSet Audio Streaming Interface Descriptor */
          AUDIO_20_STREAMING_INTERFACE_DESC_SIZE,  /* bLength */
          AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
          AUDIO_STREAMING_GENERAL,              /* bDescriptorSubtype */
          AUDIO_HEADSET_IN_TERMINAL_ID,                          /* 0x01: bTerminalLink */
          0x00,                                 /* bmControls */
          AUDIO_FORMAT_TYPE_I,                  /* bFormatType */
          0x01,                                 /* bmFormats PCM */
          0x00,
          0x00,
          0x00,
          0x02,                                 /* bNrChannels */
          0x03,                                 /* bmChannelConfig */
          0x00,
          0x00,
          0x00,
          0x00,                                 /* iChannelNames */
          /* 16 byte*/

          /* USB Speaker Audio Type I Format Interface Descriptor */
          0x06,                                 /* bLength */
          AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
          AUDIO_STREAMING_FORMAT_TYPE,          /* bDescriptorSubtype */
          AUDIO_FORMAT_TYPE_I,                  /* bFormatType */
          HALF_WORD_BYTES,                      /* bSubslotSize */
          SAMPLE_BITS,                          /* bBitResolution */
          /* 6 byte*/

          /* Endpoint 1 - Standard Descriptor */
          AUDIO_20_STANDARD_ENDPOINT_DESC_SIZE, /* bLength */
          USB_ENDPOINT_DESCRIPTOR_TYPE,         /* bDescriptorType */
          0x03,                                 /* bEndpointAddress 3 out endpoint for Audio */
          USB_ENDPOINT_TYPE_ISOCHRONOUS,        /* bmAttributes */
          0x00,0x04,//1024 /*AUDIO_PACKET_SZE(USBD_AUDIO_FREQ_HS),*/    /* XXXX wMaxPacketSize in Bytes (Freq(Samples)*2(Stereo)*2(HalfWord)) */
          0x01,                                 /* bInterval */
          /* 07 byte*/

          /* Endpoint - Audio Streaming Descriptor*/
          AUDIO_20_STREAMING_ENDPOINT_DESC_SIZE,/* bLength */
          AUDIO_ENDPOINT_DESCRIPTOR_TYPE,       /* bDescriptorType */
          AUDIO_ENDPOINT_GENERAL,               /* bDescriptor */
          0x00,                                 /* bmAttributes */
          0x00,                                 /* bmControls */
          0x00,                                 /* bLockDelayUnits */
          0x00,                                 /* wLockDelay */
          0x00,
          /* 08 byte*/
#endif

#if 1       //mic Ƶ 55
          /* USB HeadSet Standard AS Interface Descriptor - Audio Streaming Zero Bandwidth */
          /* Interface 1, Alternate Setting 0                                              */
          AUDIO_INTERFACE_DESC_SIZE,            /* bLength */
          USB_INTERFACE_DESCRIPTOR_TYPE,        /* bDescriptorType */
          0x02,                                 /* bInterfaceNumber */
          0x00,                                 /* bAlternateSetting */
          0x00,                                 /* bNumEndpoints */
          USB_DEVICE_CLASS_AUDIO,               /* bInterfaceClass */
          AUDIO_SUBCLASS_AUDIOSTREAMING,        /* bInterfaceSubClass */
          AUDIO_IP_VERSION_02_00,               /* bInterfaceProtocol */
          0x00,                                 /* iInterface */
          /* 09 byte*/

          /* USB Speaker Standard AS Interface Descriptor - Audio Streaming Operational */
          /* Interface 1, Alternate Setting 1                                           */
          AUDIO_INTERFACE_DESC_SIZE,            /* bLength */
          USB_INTERFACE_DESCRIPTOR_TYPE,        /* bDescriptorType */
          0x02,                                 /* bInterfaceNumber */
          0x01,                                 /* bAlternateSetting */
          0x01,                                 /* bNumEndpoints */
          USB_DEVICE_CLASS_AUDIO,               /* bInterfaceClass */
          AUDIO_SUBCLASS_AUDIOSTREAMING,        /* bInterfaceSubClass */
          AUDIO_IP_VERSION_02_00,               /* bInterfaceProtocol */
          0x00,                                 /* iInterface */
          /* 09 byte*/

          /* USB HeadSet Audio Streaming Interface Descriptor */
          AUDIO_20_STREAMING_INTERFACE_DESC_SIZE,  /* bLength */
          AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
          AUDIO_STREAMING_GENERAL,              /* bDescriptorSubtype */
          AUDIO_MICPHONE_OUT_TERMINAL_ID,       /*  bTerminalLink */
          0x00,                                 /* bmControls */
          AUDIO_FORMAT_TYPE_I,                  /* bFormatType */
          0x01,                                 /* bmFormats PCM */
          0x00,
          0x00,
          0x00,
          0x02,                                 /* bNrChannels */
          0x03,                                 /* bmChannelConfig */
          0x00,
          0x00,
          0x00,
          0x00,                                 /* iChannelNames */
          /* 16 byte*/

          /* USB Speaker Audio Type I Format Interface Descriptor */
          0x06,                                 /* bLength */
          AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
          AUDIO_STREAMING_FORMAT_TYPE,          /* bDescriptorSubtype */
          AUDIO_FORMAT_TYPE_I,                  /* bFormatType */
          HALF_WORD_BYTES,                      /* bSubslotSize */
          SAMPLE_BITS,                          /* bBitResolution */
          /* 6 byte*/

          /* Endpoint 1 - Standard Descriptor */
          AUDIO_20_STANDARD_ENDPOINT_DESC_SIZE, /* bLength */
          USB_ENDPOINT_DESCRIPTOR_TYPE,         /* bDescriptorType */
          0x83,                         /* bEndpointAddress 3 out endpoint for Audio */
          USB_ENDPOINT_TYPE_ISOCHRONOUS,           /* bmAttributes */
          0x00,0x04,//AUDIO_PACKET_SZE(USBD_AUDIO_FREQ_HS),    /* XXXX wMaxPacketSize in Bytes (Freq(Samples)*2(Stereo)*2(HalfWord)) */
          0x01,                                 /* bInterval */
          /* 07 byte*/

          /* Endpoint - Audio Streaming Descriptor*/
          AUDIO_20_STREAMING_ENDPOINT_DESC_SIZE,/* bLength */
          AUDIO_ENDPOINT_DESCRIPTOR_TYPE,       /* bDescriptorType */
          AUDIO_ENDPOINT_GENERAL,               /* bDescriptor */
          0x00,                                 /* bmAttributes */
          0x00,                                 /* bmControls */
          0x00,                                 /* bLockDelayUnits */
          0x00,                                 /* wLockDelay */
          0x00
          /* 08 byte*/
#endif

#endif
};


/* USB(ȫ) */

UINT8  MyCfgDescr_FS[ ] =
{
#if 1
#if 1   // ֽӿ 9Byte
        /* Configuration 1 */
         0x09,                                 /* bLength */
         USB_DESC_TYPE_CONFIGURATION,          /* bDescriptorType */
         LOBYTE(USB_AUDIO_CONFIG_DESC_SIZ),    /* wTotalLength */
         HIBYTE(USB_AUDIO_CONFIG_DESC_SIZ),
         0x03,                                 /* bNumInterfaces  audio+speaker AS+mic AS*/
         0x01,                                 /* bConfigurationValue */
         0x00,                                 /* iConfiguration */
         0x80,                                 /* bmAttributes: Bus Powered according to user configuration */
         USBD_MAX_POWER,                       /* MaxPower (mA) */
         /* 09 byte*/
#endif

#if 1   //audio 19Byte
         /* USB audio Standard interface descriptor */
         AUDIO_INTERFACE_DESC_SIZE,            /* bLength */
         USB_DESC_TYPE_INTERFACE,              /* bDescriptorType */
         0x00,                                 /* bInterfaceNumber */
         0x00,                                 /* bAlternateSetting */
         0x00,                                 /* bNumEndpoints */
         USB_DEVICE_CLASS_AUDIO,               /* bInterfaceClass */
         AUDIO_SUBCLASS_AUDIOCONTROL,          /* bInterfaceSubClass */
         AUDIO_PROTOCOL_UNDEFINED,             /* bInterfaceProtocol */
         0x00,                                 /* iInterface */
         /* 09 byte*/

         /* USB audio Class-specific AC Interface Descriptor */
         (8+2),            /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_CONTROL_HEADER,                 /* bDescriptorSubtype */
         0x00,          /* 1.00 */             /* bcdADC */
         0x01,
         (30+30+8+2),                          /* wTotalLength */
         0x00,
         0x02,                                 /* bInCollection speaker+mic*/
         0x01,                                 /* baInterfaceNr1 speaker */
         0x02,                                 /* baInterfaceNr2 mic */
         /* 10 byte*/
#endif

#if 1   /*30 Byte Speakerն*/
         /* USB Speaker Input Terminal Descriptor */
         AUDIO_INPUT_TERMINAL_DESC_SIZE,       /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_CONTROL_INPUT_TERMINAL,         /* bDescriptorSubtype */
         0x01,                                 /* bTerminalID :1*/
         0x01,                                 /* wTerminalType AUDIO_TERMINAL_USB_STREAMING   0x0101 */
         0x01,
         0x00,                                 /* bAssocTerminal */
         0x01,                                 /* bNrChannels */
         0x00,                                 /* wChannelConfig 0x0000  Mono */
         0x00,
         0x00,                                 /* iChannelNames */
         0x00,                                 /* iTerminal */
         /* 12 byte*/

         /* USB Speaker Audio Feature Unit Descriptor */
         0x09,                                 /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_CONTROL_FEATURE_UNIT,           /* bDescriptorSubtype */
         0x02,                                 /* bUnitID :2*/
         0x01,                                 /* bSourceID :1*/
         0x01,                                 /* bControlSize */
         AUDIO_CONTROL_MUTE,                   /* bmaControls(0) */
         0,                                    /* bmaControls(1) */
         0x00,                                 /* iTerminal */
         /* 09 byte */

         /* USB Speaker Output Terminal Descriptor */
         0x09,      /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_CONTROL_OUTPUT_TERMINAL,        /* bDescriptorSubtype */
         0x03,                                 /* bTerminalID :3*/
         0x01,                                 /* wTerminalType  0x0301 */
         0x03,
         0x00,                                 /* bAssocTerminal */
         0x02,                                 /* bSourceID :2*/
         0x00,                                 /* iTerminal */
         /* 09 byte */
#endif

#if 1   /*30 Byte micն*/
         /* USB mic Input Terminal Descriptor */
         AUDIO_INPUT_TERMINAL_DESC_SIZE,       /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_CONTROL_INPUT_TERMINAL,         /* bDescriptorSubtype */
         0x04,                                 /* bTerminalID : 4*/
         0x01,                                 /* wTerminalType AUDIO_TERMINAL_USB_STREAMING   0x0201 mic*/
         0x02,
         0x00,                                 /* bAssocTerminal */
         0x01,                                 /* bNrChannels */
         0x00,                                 /* wChannelConfig 0x0000  Mono */
         0x00,
         0x00,                                 /* iChannelNames */
         0x00,                                 /* iTerminal */
         /* 12 byte*/

         /* USB mic Audio Feature Unit Descriptor */
         0x09,                                 /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_CONTROL_FEATURE_UNIT,           /* bDescriptorSubtype */
         0x05,                                 /* bUnitID :5*/
         0x04,                                 /* bSourceID :4*/
         0x01,                                 /* bControlSize */
         AUDIO_CONTROL_MUTE,                   /* bmaControls(0) */
         0,                                    /* bmaControls(1) */
         0x00,                                 /* iTerminal */
         /* 09 byte */

         /* USB mic Output Terminal Descriptor */
         0x09,      /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_CONTROL_OUTPUT_TERMINAL,        /* bDescriptorSubtype */
         0x06,                                 /* bTerminalID:6 */
         0x01,                                 /* wTerminalType  0x0101  Ƶ*/
         0x01,
         0x00,                                 /* bAssocTerminal */
         0x05,                                 /* bSourceID:5 */
         0x00,                                 /* iTerminal */
         /* 09 byte */
#endif

#if 1   /*52 Byte speaker Ƶ*/
         /* USB Speaker Standard AS Interface Descriptor - Audio Streaming Zero Bandwidth */
         /* Interface 1, Alternate Setting 0                                              */
         AUDIO_INTERFACE_DESC_SIZE,            /* bLength */
         USB_DESC_TYPE_INTERFACE,              /* bDescriptorType */
         0x01,                                 /* bInterfaceNumber */
         0x00,                                 /* bAlternateSetting */
         0x00,                                 /* bNumEndpoints */
         USB_DEVICE_CLASS_AUDIO,               /* bInterfaceClass */
         AUDIO_SUBCLASS_AUDIOSTREAMING,        /* bInterfaceSubClass */
         AUDIO_PROTOCOL_UNDEFINED,             /* bInterfaceProtocol */
         0x00,                                 /* iInterface */
         /* 09 byte*/

         /* USB Speaker Standard AS Interface Descriptor - Audio Streaming Operational */
         /* Interface 1, Alternate Setting 1                                           */
         AUDIO_INTERFACE_DESC_SIZE,            /* bLength */
         USB_DESC_TYPE_INTERFACE,              /* bDescriptorType */
         0x01,                                 /* bInterfaceNumber */
         0x01,                                 /* bAlternateSetting */
         0x01,                                 /* bNumEndpoints */
         USB_DEVICE_CLASS_AUDIO,               /* bInterfaceClass */
         AUDIO_SUBCLASS_AUDIOSTREAMING,        /* bInterfaceSubClass */
         AUDIO_PROTOCOL_UNDEFINED,             /* bInterfaceProtocol */
         0x00,                                 /* iInterface */
         /* 09 byte*/

         /* USB Speaker Audio Streaming Interface Descriptor */
         AUDIO_STREAMING_INTERFACE_DESC_SIZE,  /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_STREAMING_GENERAL,              /* bDescriptorSubtype */
         0x01,                                 /* bTerminalLink */
         0x01,                                 /* bDelay */
         0x01,                                 /* wFormatTag AUDIO_FORMAT_PCM  0x0001 */
         0x00,
         /* 07 byte*/

         /* USB Speaker Audio Type III Format Interface Descriptor */
         0x0B,                                 /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_STREAMING_FORMAT_TYPE,          /* bDescriptorSubtype */
         AUDIO_FORMAT_TYPE_I,                  /* bFormatType */
         0x02,                                 /* bNrChannels */
         0x02,                                 /* bSubFrameSize :  2 Bytes per frame (16bits) */
         16,                                   /* bBitResolution (16-bits per sample) */
         0x01,                                 /* bSamFreqType only one frequency supported */
         AUDIO_SAMPLE_FREQ(USBD_AUDIO_FREQ_FS),   /* Audio sampling frequency coded on 3 bytes */
         /* 11 byte*/

         /* Endpoint 1 - Standard Descriptor */
         AUDIO_STANDARD_ENDPOINT_DESC_SIZE,    /* bLength */
         USB_DESC_TYPE_ENDPOINT,               /* bDescriptorType */
         0x03,                         /* bEndpointAddress 1 out endpoint */
         USBD_EP_TYPE_ISOC,                    /* bmAttributes */
         AUDIO_PACKET_SZE(USBD_AUDIO_FREQ_FS),    /* wMaxPacketSize in Bytes (Freq(Samples)*2(Stereo)*2(HalfWord)) */
         AUDIO_FS_BINTERVAL,                   /* bInterval */
         0x00,                                 /* bRefresh */
         0x00,                                 /* bSynchAddress */
         /* 09 byte*/

         /* Endpoint - Audio Streaming Descriptor */
         AUDIO_STREAMING_ENDPOINT_DESC_SIZE,   /* bLength */
         AUDIO_ENDPOINT_DESCRIPTOR_TYPE,       /* bDescriptorType */
         AUDIO_ENDPOINT_GENERAL,               /* bDescriptor */
         0x00,                                 /* bmAttributes */
         0x00,                                 /* bLockDelayUnits */
         0x00,                                 /* wLockDelay */
         0x00,

#endif

#if 1   /*52 Byte mic Ƶ*/

         /* USB mic Standard AS Interface Descriptor - Audio Streaming Zero Bandwidth */
         /* Interface 1, Alternate Setting 0                                              */
         AUDIO_INTERFACE_DESC_SIZE,            /* bLength */
         USB_DESC_TYPE_INTERFACE,              /* bDescriptorType */
         0x02,                                 /* bInterfaceNumber :2*/
         0x00,                                 /* bAlternateSetting */
         0x00,                                 /* bNumEndpoints */
         USB_DEVICE_CLASS_AUDIO,               /* bInterfaceClass */
         AUDIO_SUBCLASS_AUDIOSTREAMING,        /* bInterfaceSubClass */
         AUDIO_PROTOCOL_UNDEFINED,             /* bInterfaceProtocol */
         0x00,                                 /* iInterface */
         /* 09 byte*/

         /* USB mic Standard AS Interface Descriptor - Audio Streaming Operational */
         /* Interface 1, Alternate Setting 1                                           */
         AUDIO_INTERFACE_DESC_SIZE,            /* bLength */
         USB_DESC_TYPE_INTERFACE,              /* bDescriptorType */
         0x02,                                 /* bInterfaceNumber :2*/
         0x01,                                 /* bAlternateSetting */
         0x01,                                 /* bNumEndpoints */
         USB_DEVICE_CLASS_AUDIO,               /* bInterfaceClass */
         AUDIO_SUBCLASS_AUDIOSTREAMING,        /* bInterfaceSubClass */
         AUDIO_PROTOCOL_UNDEFINED,             /* bInterfaceProtocol */
         0x00,                                 /* iInterface */
         /* 09 byte*/

         /* USB mic Audio Streaming Interface Descriptor */
         AUDIO_STREAMING_INTERFACE_DESC_SIZE,  /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_STREAMING_GENERAL,              /* bDescriptorSubtype */
         0x06,                                 /* bTerminalLink:6 micն*/
         0x01,                                 /* bDelay */
         0x01,                                 /* wFormatTag AUDIO_FORMAT_PCM  0x0001 */
         0x00,
         /* 07 byte*/

         /* USB Speaker Audio Type III Format Interface Descriptor */
         0x0B,                                 /* bLength */
         AUDIO_INTERFACE_DESCRIPTOR_TYPE,      /* bDescriptorType */
         AUDIO_STREAMING_FORMAT_TYPE,          /* bDescriptorSubtype */
         AUDIO_FORMAT_TYPE_I,                  /* bFormatType */
         0x02,                                 /* bNrChannels */
         0x02,                                 /* bSubFrameSize :  2 Bytes per frame (16bits) */
         16,                                   /* bBitResolution (16-bits per sample) */
         0x01,                                 /* bSamFreqType only one frequency supported */
         AUDIO_SAMPLE_FREQ(USBD_AUDIO_FREQ_FS),   /* Audio sampling frequency coded on 3 bytes */
         /* 11 byte*/

         /* Endpoint 1 - Standard Descriptor */
         AUDIO_STANDARD_ENDPOINT_DESC_SIZE,    /* bLength */
         USB_DESC_TYPE_ENDPOINT,               /* bDescriptorType */
         0x83,                                 /* bEndpointAddress 1 in endpoint */
         USBD_EP_TYPE_ISOC,                    /* bmAttributes */
         AUDIO_PACKET_SZE(USBD_AUDIO_FREQ_FS),    /* wMaxPacketSize in Bytes (Freq(Samples)*2(Stereo)*2(HalfWord)) */
         AUDIO_FS_BINTERVAL,                   /* bInterval */
         0x00,                                 /* bRefresh */
         0x00,                                 /* bSynchAddress */
         /* 09 byte*/

         /* Endpoint - Audio Streaming Descriptor */
         AUDIO_STREAMING_ENDPOINT_DESC_SIZE,   /* bLength */
         AUDIO_ENDPOINT_DESCRIPTOR_TYPE,       /* bDescriptorType */
         AUDIO_ENDPOINT_GENERAL,               /* bDescriptor */
         0x00,                                 /* bmAttributes */
         0x00,                                 /* bLockDelayUnits */
         0x00,                                 /* wLockDelay */
         0x00,

#endif

#endif
};


/* USBַ */
const UINT8  MyLangDescr[ ] =
{
    0x04,0x03,0x09,0x04
};

/* USBַ */
const UINT8  MyManuInfo[ ] =
{
    /* wch.cn */
    0x0E,0x03,
    'w',0,'c',0,'h',0,'.',0,'c',0,'n',0
};

/* USBƷַ */
const UINT8  MyProdInfo[ ] =
{
    /* WCH USB2.0 Audio */
    0x24,0x03,
    'W',0,'C',0,'H',0,' ',0,'U',0,'S',0,'B',0,'2',0,
    '.',0,'0',0,' ',0,'A',0,'u',0,'d',0,'i',0,'o',0,
    ' ',0
};

/* USBкַ */
const UINT8  MySerNumInfo[ ] =
{
    /* 0123456789 */
    0x16,0x03,
    '0',0,'1',0,'2',0,'3',0,'4',0,'5',0,'6',0,'7',0,
    '8',0,'9',0
};

/* USB豸޶ */
const UINT8 MyUSBQUADesc[ ] =
{
    0x0A, 0x06, 0x00, 0x02, 0xFF, 0x00, 0xFF, 0x40, 0x01, 0x00,
};

/* BOS */
const UINT8 MyBOSDesc[ ] =
{
    0x05,0x0f,0x16,0x00,0x02,
    0x07,0x10,0x02,0x02,0x00,0x00,0x00,
    0x0a,0x10,0x03,0x00,0x0e,0x00,0x01,0x0a,0xff,0x07,
};
/* USBȫģʽ,ٶ */
UINT8 TAB_USB_FS_OSC_DESC[sizeof(MyCfgDescr_HS)+2] =
{
    0x09, 0x07,                                                                 /* ͨ */
};

/* USBģʽ,ٶ */
UINT8 TAB_USB_HS_OSC_DESC[sizeof(MyCfgDescr_FS)+2] =
{
    0x09, 0x07,                                                                 /* ͨ */
};

/*********************************************************************
 * @fn      USBHS_RCC_Init
 *
 * @brief   Initializes the clock for USB2.0 High speed device.
 *
 * @return  none
 */
void USBHS_RCC_Init( void )
{
#if 0
    RCC->CFGR2 = USBHS_PLL_SRC_HSE | USBHS_PLL_SRC_PRE_DIV2 | USBHS_PLL_CKREF_4M; /* PLL REF = HSE/2 = 4MHz */
    RCC->CFGR2 |= USB_48M_CLK_SRC_PHY | USBHS_PLL_ALIVE;
    RCC->AHBPCENR |= ( (uint32_t)( 1 << 11 ) );
#else
    RCC_USBHSPLLCLKConfig( RCC_HSBHSPLLCLKSource_HSE );
    RCC_USBHSConfig( RCC_USBPLL_Div2 );
    RCC_USBHSPLLCKREFCLKConfig( RCC_USBHSPLLCKREFCLK_4M );
    RCC_USBCLK48MConfig( RCC_USBCLK48MCLKSource_USBPHY );
    RCC_USBHSPHYPLLALIVEcmd( ENABLE );
    RCC_AHBPeriphClockCmd( RCC_AHBPeriph_USBHS, ENABLE );
#endif
    Delay_Us( 200 );
}

/*********************************************************************
 * @fn      USBHS_Device_Endp_Init
 *
 * @brief   USB2.0豸˵ʼ
 *
 * @return  none
 */

void USBHS_Device_Endp_Init ( void )
{
#if  LOOP_TEST
    pEP3BUF_RX=EP3_Rx_Databuf;
    pEP3BUF_TX=EP3_Rx_Databuf;
#else
    pbuf=buf;
    pbuf_tx=buf;
    pbuf_rx=buf;
#endif
    /* ʹܶ˵1˵2ͺͽ  */
    USBHSD->ENDP_CONFIG = USBHS_EP0_T_EN | USBHS_EP0_R_EN | USBHS_EP3_T_EN | USBHS_EP3_R_EN;

    /* ˵ͬ˵ */
    USBHSD->ENDP_TYPE =USBHS_EP3_T_TYP|USBHS_EP3_R_TYP;

    /* ˵㻺ģʽ˫ISOBUFģʽҪָ0  */
    USBHSD->BUF_MODE = 0;

    /* ˵󳤶Ȱ */
    USBHSD->UEP0_MAX_LEN = 64;

    USBHSD->UEP3_MAX_LEN = DEF_USBD_SYC_PACK_SIZE;


    /* ˵DMAַ */
    USBHSD->UEP0_DMA    = (UINT32)(UINT8 *)EP0_Databuf;
#if LOOP_TEST
    USBHSD->UEP3_TX_DMA = (UINT32)(UINT8 *)EP3_Rx_Databuf;  /*һشð*/
#else
    USBHSD->UEP3_TX_DMA = (UINT32)(UINT8 *)EP3_Tx_Databuf;
#endif
    USBHSD->UEP3_RX_DMA = (UINT32)(UINT8 *)EP3_Rx_Databuf;


    /* ˵ƼĴ */
    USBHSD->UEP0_TX_LEN  = 0;
    USBHSD->UEP0_TX_CTRL = USBHS_EP_T_RES_NAK;
    USBHSD->UEP0_RX_CTRL = USBHS_EP_R_RES_ACK;

    USBHSD->UEP3_TX_LEN  = 0;
    USBHSD->UEP3_TX_CTRL = USBHS_EP_T_TOG_0;//ͬ ҪACK ҪתDATA0/1DATA0
    USBHSD->UEP3_RX_CTRL = USBHS_EP_R_TOG_0;

}

/*********************************************************************
 * @fn      USBHS_Device_Init
 *
 * @brief   USB2.0豸ʼ
 *
 * @return  none
 */
void USBHS_Device_Init ( FunctionalState sta )
{
    if( sta )
    {

        /* DMAٶȡ˵ʹܵ */
        USBHSD->HOST_CTRL = 0x00;
        USBHSD->HOST_CTRL = USBHS_SUSPENDM;

        USBHSD->CONTROL = 0;
#if DEF_USBD_SPEED == DEF_USBD_SPEED_HIGH
        USBHSD->CONTROL   = USBHS_DMA_EN | USBHS_INT_BUSY_EN | USBHS_HIGH_SPEED;
#elif DEF_USBD_SPEED == DEF_USBD_SPEED_FULL
        USBHSD->CONTROL   = USBHS_DMA_EN | USBHS_INT_BUSY_EN | USBHS_FULL_SPEED;
#elif DEF_USBD_SPEED == DEF_USBD_SPEED_LOW
        USBHSD->CONTROL   = USBHS_DMA_EN | USBHS_INT_BUSY_EN | USBHS_LOW_SPEED;
#endif

        USBHSD->INT_EN    = 0;
        USBHSD->INT_EN    = USBHS_SETUP_ACT_EN | USBHS_TRANSFER_EN | USBHS_DETECT_EN | USBHS_SUSPEND_EN;

        /* ALL endpoint enable */
        USBHSD->ENDP_CONFIG = 0xffffffff;

        /* USB2.0豸˵ʼ */
        USBHS_Device_Endp_Init( );
        Delay_Us(10);

        /* ʹUSB */
        USBHSD->CONTROL |= USBHS_DEV_PU_EN;
    }
    else
    {
        USBHSD->CONTROL &= ~USBHS_DEV_PU_EN;
        USBHSD->CONTROL |= USBHS_ALL_CLR | USBHS_FORCE_RST;
    }
}



/*********************************************************************
 * @fn      USBHS_Device_SetAddress
 *
 * @brief   USB2.0豸豸ַ
 *
 * @return  none
 */
void USBHS_Device_SetAddress( UINT32 address )
{
    USBHSD->DEV_AD = 0;
    USBHSD->DEV_AD = address & 0xff;
}

/*********************************************************************
 * @fn      USBHS_IRQHandler
 *
 * @brief   This function handles USBHS exception.
 *
 * @return  none
 */

extern volatile u8 flag_transfer_1024;
u8 time_rx,time_tx=0;
u16 time=0;
void USBHS_IRQHandler( void )
{
    UINT32 end_num;
    UINT32 rx_token;
    UINT16 len = 0x00;
    UINT8  errflag = 0x00;
    UINT8  chtype;
    USBHS_Int_Flag = USBHSD->INT_FG;
    if( USBHS_Int_Flag & USBHS_TRANSFER_FLAG )
    {
        /* ˵㴫䴦 */
        end_num  = (USBHSD->INT_ST) & MASK_UIS_ENDP;
        rx_token = ( ( (USBHSD->INT_ST) & MASK_UIS_TOKEN ) >> 4 ) & 0x03;

#if 0
        if( !( USBHS->STATUS & TOG_MATCH ) )
        {
            DUG_PRINTF(" TOG MATCH FAIL : ENDP %x token %x \n", end_num, rx_token);
        }
#endif
        if( end_num == 0 )
        {
            /* ˵0 */
            if( rx_token == PID_IN )
            {
                /* ˵0ϴɹж */
                switch( USBHS_Dev_SetupReqCode )
                {
                    case USB_GET_DESCRIPTOR:
                        len = USBHS_Dev_SetupReqLen >= DEF_USBD_UEP0_SIZE ? DEF_USBD_UEP0_SIZE : USBHS_Dev_SetupReqLen;
                        memcpy( EP0_Databuf, pDescr, len );
                        USBHS_Dev_SetupReqLen -= len;
                        pDescr += len;
                        USBHS_Dev_Endp0_Tog ^= 1;
                        USBHSD->UEP0_TX_LEN  = len;
                        USBHSD->UEP0_TX_CTRL =  USBHS_EP_T_RES_ACK | ( USBHS_Dev_Endp0_Tog ? USBHS_EP_T_TOG_0 : USBHS_EP_T_TOG_1 );
                        break;

                    case 0x02:
                        len = USBHS_Dev_SetupReqLen >= DEF_USBD_UEP0_SIZE ? DEF_USBD_UEP0_SIZE : USBHS_Dev_SetupReqLen;
                        memcpy( EP0_Databuf, pDescr, len );
                        USBHS_Dev_SetupReqLen -= len;
                        pDescr += len;
                        USBHS_Dev_Endp0_Tog ^= 1;
                        USBHSD->UEP0_TX_LEN  = len;
                        USBHSD->UEP0_TX_CTRL =  USBHS_EP_T_RES_ACK | ( USBHS_Dev_Endp0_Tog ? USBHS_EP_T_TOG_0 : USBHS_EP_T_TOG_1 );
                        break;

                    case USB_SET_ADDRESS:
                        USBHS_Device_SetAddress( USBHS_Dev_Address );
                        USBHSD->UEP0_TX_LEN = 0;
                        USBHSD->UEP0_TX_CTRL = 0;
                        USBHSD->UEP0_RX_CTRL = 0;
                        break;

                    default:
                        /* ״̬׶жϻǿϴ0ݰƴ */
                        USBHSD->UEP0_RX_CTRL = USBHS_EP_R_RES_ACK | USBHS_EP_R_TOG_1;
                        pDescr = NULL;
                        break;
                }
            }
            else if( rx_token == PID_OUT )
            {
                USBHSD->UEP0_TX_LEN  = 0;
                USBHSD->UEP0_TX_CTRL = USBHS_EP_T_RES_ACK | USBHS_EP_T_TOG_1;
            }
        }
        else if( end_num == 3 )
        {
            if( rx_token == PID_IN )
            {

#if LOOP_TEST   //شԣEP3ݻشԣPA01024ֽÿ

                if(flag_transfer_1024==1)//EP3һ1024,ûùر
                {
#if 1
                    buf_1024[0]++;

#else
                    /*buf_1024ֱܳ޸dmaַ,˴ṹ*/

                     if(time==9)//β   9=bufܴС10240 /1024  -1
                     {
                         USBHSD->UEP3_TX_DMA=(u32)buf_1024;
                         time=0;
                     }
                     else
                     {
                         time++;
                         USBHSD->UEP3_TX_DMA=(u32)(buf_1024+time*1024);//
                     }
                     USBHSD->UEP3_TX_LEN=1024;
                     USBHSD->UEP3_TX_CTRL =0;

#endif
                }
                else
                {
                    if(ready_flag==1)
                    {
                        if(pvalue>1)//RXBUF
                        {
                            pvalue--;//ݰ
                            time_tx++;
                            USBHSD->UEP3_TX_DMA+=EP3_RX_len;
                            USBHSD->UEP3_TX_LEN=EP3_RX_len;
                            USBHSD->UEP3_TX_CTRL =0;
                            if(time_tx>=50)//ͷʼ˴ҪOUTһ
                            {
                                time_tx=0;
                                USBHSD->UEP3_TX_DMA=(u32)EP3_Rx_Databuf;
                            }
                        }
                        else
                        {
                            USBHSD->UEP3_TX_LEN=0;
                        }
                    }
                }
#else           //ʹûλRX TXֿ

                if(flag_transfer_1024==1)
                {
                    buf_1024[0]++;
                }
                else
                {
                    if(buf_value>=EP3_RX_len)//λ
                    {
                            if(pbuf_tx>(buf+buf_size))//˻󣬴ͷʼȡ
                            {
                                pbuf_tx=buf;
                            }
                            memcpy( EP3_Tx_Databuf, pbuf_tx, EP3_RX_len );
                            pbuf_tx+=EP3_RX_len;

                            USBHSD->UEP3_TX_LEN   = EP3_RX_len;
                            USBHSD->UEP3_TX_CTRL =0;
                            buf_value-=EP3_RX_len;
                    }
                    else
                    {
                        USBOTG_FS->UEP3_TX_LEN = 0;
                    }
                }
#endif
            }
            else if( rx_token == PID_OUT )
            {

#if LOOP_TEST   //ش,շһ   HS144ֽ192000HZ 24λ
                    time_rx++;//
                    pvalue++;//а
                    EP3_RX_len=USBHSD->RX_LEN;
                    USBHSD->UEP3_RX_DMA+=EP3_RX_len;// һ
                    if(pvalue>10)//Ԥ10ݺ󣬿ͻش
                    {
                        ready_flag=1;
                    }
                    if(time_rx>=50)//50Σֹͷţ50Ǵûоȷ㣬ܳ С/ֽ
                    {
                        time_rx=0;
                        USBHSD->UEP3_RX_DMA=(u32)EP3_Rx_Databuf;
                    }


#else           //RX TXֱʹòͬһλ

                    EP3_RX_len= USBHSD->RX_LEN;
                    if(pbuf_rx>(buf+buf_size))//buf滹ʣһ㣬ֱӴͷʼ
                    {
                        pbuf_rx=buf;
                    }

                    memcpy( pbuf_rx, EP3_Rx_Databuf, EP3_RX_len );
                    pbuf_rx+=EP3_RX_len;
                    buf_value+=EP3_RX_len;

#endif

            }
            else if( rx_token == PID_SOF )
            {

            }
        }
        USBHSD->INT_FG = USBHS_TRANSFER_FLAG;
    }
    else if( USBHS_Int_Flag & USBHS_SETUP_FLAG )
    {
     /* SETUP */
     USBHS_Dev_SetupReqLen = pMySetupReqPak->wLength;
     USBHS_Dev_SetupReqCode = pMySetupReqPak->bRequest;
     chtype = pMySetupReqPak->bRequestType;
     len = 0x00;
     errflag = 0x00;

     /* жϵǰǱ׼ */
     if( ( pMySetupReqPak->bRequestType & USB_REQ_TYP_MASK ) != USB_REQ_TYP_STANDARD )
     {
         /* ,, */
         if( pMySetupReqPak->bRequestType & 0x40 )
         {
             /*  */
             switch( USBHS_Dev_SetupReqCode )
             {
                 default:
                     errflag = 0xFF;/* ʧ */
                     break;
             }
         }
         else if(pMySetupReqPak->bRequestType == 0xa1)
         {
#if DEF_USBD_SPEED == 0
              if(pMySetupReqPak->wIndex==(AUDIO_CLOCK_ID<<8))//Clock
              {
                  if(pMySetupReqPak->wValue==0x0000)
                  {

                  }
                  if(pMySetupReqPak->wValue==0x0100)
                  {
                      switch (pMySetupReqPak->bRequest)
                      {
                      case 1://CUR
                          if(pMySetupReqPak->bRequest&0x80)//GET
                          {
                              u8 Class_Request_Buf[4]={SAMPLE_FREQ_4B(USBD_AUDIO_FREQ_HS)};
                              pDescr=Class_Request_Buf;
                              len=0x04;
                          }
                          else//SET
                          {
                              u8 Class_Request_Buf[4]={0x00};
                              pDescr=Class_Request_Buf;
                              len=0x04;
                          }
                          break;
                      case 2://RANGE
                          if(pMySetupReqPak->bRequestType&0x80)//GET
                          {
                              u8 Class_Request_Buf[]=
                              {
                                  SAMPLE_FREQ_NUM(1),           /* wNumSubRanges */

                                  SAMPLE_FREQ_4B(USBD_AUDIO_FREQ_HS),       /* dMIN(1) */
                                  SAMPLE_FREQ_4B(USBD_AUDIO_FREQ_HS),       /* dMAX(1) */
                                  SAMPLE_FREQ_4B(0x00)          /* dRES(1) */
                              };
                              pDescr=Class_Request_Buf;
                              len=sizeof(Class_Request_Buf);
                          }
                          break;
                      }
                  }
                  if(pMySetupReqPak->wValue==0x0200)
                  {
                      if((pMySetupReqPak->bRequestType&0x80)&&(pMySetupReqPak->bRequest==0x01))
                      {
                          u8 Class_Request_Buf[1]={1};
                          pDescr=Class_Request_Buf;
                          len=0x01;
                      }
                  }

              }
              if(pMySetupReqPak->wIndex&0x700)//Feature
              {
                  if(pMySetupReqPak->wValue==0x200)
                  {
                      switch(pMySetupReqPak->bRequest)
                      {
                            case 1://CUR
                                if(pMySetupReqPak->bRequestType&0x80)//get
                                {
                                    u8 Class_Request_Buf[1]={50};
                                    pDescr=Class_Request_Buf;
                                    len=0x01;
                                }
                                else//SET CUR
                                {

                                }
                                break;
                            case 2://RANGE
                                if(pMySetupReqPak->bRequestType&0x80)//get
                                {
                                    u8 Class_Request_Buf[8]=
                                    {
                                        1,0,    //wNumSubRanges
                                        0,0,    //wMIN(1)
                                        100,0,  //wMAX(1)
                                        1,0     //wRES(1)
                                    };

                                    pDescr=Class_Request_Buf;
                                    len=0x08;
                                }
                                else//SET range
                                {

                                }
                                break;

                      }
                  }
                  if(pMySetupReqPak->wValue==0x100)
                  {
                      if(pMySetupReqPak->bRequest==0x01)
                      {
                          if(pMySetupReqPak->bRequestType&0x80)//GET CUR
                          {
                              u8 Class_Request_Buf[1]={0};
                              pDescr=Class_Request_Buf;
                              len=0x01;
                          }
                          else
                          {

                          }
                      }
                  }

              }
#elif DEF_USBD_SPEED == DEF_USBD_SPEED_FULL
              if(pMySetupReqPak->bRequest==0x81)//GET CUR
              {
                  u8 Class_Request_Buf[1]={0};
                  pDescr=Class_Request_Buf;
                  len=1;
              }
#endif

         }
         else if( pMySetupReqPak->bRequestType & 0x20 )
         {
             /* HID */
             switch( USBHS_Dev_SetupReqCode )
             {
             case 0x01: //GetReport
                 break;
             case 0x02: //GetIdle SET MIN
                 break;
             case 0x03: //GetProtocol
                 break;
             case 0x09: //SetReport
                 break;
             case 0x0A: //SetIdle
                 break;
             case 0x0B: //SetProtocol
                 break;
             default:
                 errflag = 0xFF;
                 break;
             }
         }

         /* жǷ */
         if( errflag != 0xFF )
         {
             if( USBHS_Dev_SetupReqLen > len )
             {
                 USBHS_Dev_SetupReqLen = len;
             }
             len = ( USBHS_Dev_SetupReqLen >= DEF_USBD_UEP0_SIZE ) ? DEF_USBD_UEP0_SIZE : USBHS_Dev_SetupReqLen;
             memcpy( EP0_Databuf, pDescr, len );
             pDescr += len;
         }
     }
     else
     {
         /* ׼USB */
         switch( USBHS_Dev_SetupReqCode )
         {
             case USB_GET_DESCRIPTOR:
             {
                 switch( ( ( pMySetupReqPak->wValue ) >> 8 ) )
                 {
                     case USB_DESCR_TYP_DEVICE:
                         /* ȡ豸 */
                         pDescr = MyDevDescr;
                         len = MyDevDescr[ 0 ];
                         break;

                     case USB_DESCR_TYP_CONFIG:
                         /* ȡ */
#if DEF_USBD_SPEED == DEF_USBD_SPEED_HIGH
                         pDescr = MyCfgDescr_HS;
                         len = sizeof( MyCfgDescr_HS );
#elif DEF_USBD_SPEED == DEF_USBD_SPEED_FULL
                         pDescr = MyCfgDescr_FS;
                         len = sizeof( MyCfgDescr_FS );
#elif DEF_USBD_SPEED == DEF_USBD_SPEED_LOW
                         pDescr = MyCfgDescr_LS;
                         len = sizeof( MyCfgDescr_LS );
#endif
                         break;

                     case USB_DESCR_TYP_STRING:
                         /* ȡַ */
                         switch( ( pMySetupReqPak->wValue ) & 0xff )
                         {
                             case 0:
                                 /* ַ */
                                 pDescr = MyLangDescr;
                                 len = MyLangDescr[ 0 ];
                                 break;

                             case 1:
                                 /* USBַ */
                                 pDescr = MyManuInfo;
                                 len = sizeof( MyManuInfo );
                                 break;

                             case 2:
                                 /* USBƷַ */
                                 pDescr = MyProdInfo;
                                 len = sizeof( MyProdInfo );
                                 break;

                             case 3:
                                 /* USBкַ */
                                 pDescr = MySerNumInfo;
                                 len = sizeof( MySerNumInfo );
                                 break;

                             default:
                                 errflag = 0xFF;
                                 break;
                         }
                         break;

                     case USB_DESCR_TYP_REPORT:
                         /* USB豸 */
                         break;

                     case USB_DESCR_TYP_QUALIF:
                         /* 豸޶ */
                         pDescr = ( PUINT8 )&MyUSBQUADesc[ 0 ];
                         len = sizeof( MyUSBQUADesc );
                         break;

                     case USB_DESCR_TYP_SPEED:
                         /* ٶ */
                         if( USBHS_Dev_Speed == 0x01 )
                         {
                             /* ģʽ */
                             memcpy( &TAB_USB_HS_OSC_DESC[ 2 ], &MyCfgDescr_FS[ 2 ], sizeof( MyCfgDescr_FS ) - 2 );
                             pDescr = ( PUINT8 )&TAB_USB_HS_OSC_DESC[ 0 ];
                             len = sizeof( TAB_USB_HS_OSC_DESC );
                         }
                         else if( USBHS_Dev_Speed == 0x00 )
                         {
                             /* ȫģʽ */
                             memcpy( &TAB_USB_FS_OSC_DESC[ 2 ], &MyCfgDescr_HS[ 2 ], sizeof( MyCfgDescr_HS ) - 2 );
                             pDescr = ( PUINT8 )&TAB_USB_FS_OSC_DESC[ 0 ];
                             len = sizeof( TAB_USB_FS_OSC_DESC );
                         }
                         else
                         {
                             errflag = 0xFF;
                         }
                         break;

                     case USB_DESCR_TYP_BOS:
                         /* BOS */
                         /* USB2.0豸֧BOS */
                         errflag = 0xFF;
                         break;
                     default :
                         errflag = 0xFF;
                         break;
                 }

                 /* жǷ */
                 if( errflag != 0xFF )
                 {
                     if( USBHS_Dev_SetupReqLen > len )
                     {
                         USBHS_Dev_SetupReqLen = len;
                     }
                     len = ( USBHS_Dev_SetupReqLen >= DEF_USBD_UEP0_SIZE ) ? DEF_USBD_UEP0_SIZE : USBHS_Dev_SetupReqLen;
                     memcpy( EP0_Databuf, pDescr, len );
                     pDescr += len;
                 }
             }
             break;

             case USB_SET_ADDRESS:
                 /* õַ */
                 USBHS_Dev_Address = ( pMySetupReqPak->wValue )& 0xff;
                 break;

             case USB_GET_CONFIGURATION:
                 /* ȡֵ */
                 EP0_Databuf[ 0 ] = USBHS_Dev_Config;
                 if( USBHS_Dev_SetupReqLen > 1 )
                 {
                     USBHS_Dev_SetupReqLen = 1;
                 }
                 break;

             case USB_SET_CONFIGURATION:
                 /* ֵ */
                 USBHS_Dev_Config = ( pMySetupReqPak->wValue ) & 0xff;
                 USBHS_Dev_EnumStatus = 0x01;
                 break;

             case USB_CLEAR_FEATURE:
                 /*  */
                 if( ( pMySetupReqPak->bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_ENDP )
                 {
                     /* ˵ */
                     switch( ( pMySetupReqPak->wIndex ) & 0xff )/* wIndexL */
                     {
                         case 0x82:
                             /* SET Endp2 Tx to USBHS_EP_T_RES_NAK;USBHS_EP_T_TOG_0;len = 0 */
                             USBHSD->UEP2_TX_LEN = 0;
                             USBHSD->UEP2_TX_CTRL = USBHS_EP_T_RES_NAK | USBHS_EP_T_TOG_0;
                             break;

                         case 0x02:
                             /* SET Endp2 Rx to USBHS_EP_R_RES_ACK;USBHS_EP_R_TOG_0 */
                             USBHSD->UEP2_TX_CTRL = USBHS_EP_R_RES_ACK | USBHS_EP_R_TOG_0;
                             break;

                         case 0x81:
                             /* SET Endp1 Tx to USBHS_EP_T_RES_NAK;USBHS_EP_T_TOG_0;len = 0 */
                             USBHSD->UEP1_TX_LEN = 0;
                             USBHSD->UEP1_TX_CTRL = USBHS_EP_T_RES_NAK | USBHS_EP_T_TOG_0;
                             break;

                         case 0x01:
                             /* SET Endp1 Rx to USBHS_EP_R_RES_NAK;USBHS_EP_R_TOG_0 */
                             USBHSD->UEP1_RX_CTRL = USBHS_EP_R_RES_ACK | USBHS_EP_R_TOG_0;
                             break;

                         default:
                             errflag = 0xFF;
                             break;
                     }
                 }
                 else if( ( pMySetupReqPak->bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_DEVICE )
                 {
                     if( ( ( pMySetupReqPak->wValue ) & 0xff ) == 1 )/* wIndexL */
                     {
                         USBHS_Dev_SleepStatus &= ~0x01;
                     }
                 }
                 else
                 {
                     errflag = 0xFF;
                 }
                 break;

             case USB_SET_FEATURE:
                 /*  */
                 if( ( pMySetupReqPak->bRequestType & 0x1F ) == 0x00 )
                 {
                     /* 豸 */
                     if( pMySetupReqPak->wValue == 0x01 )
                     {
                         if( MyCfgDescr_HS[ 7 ] & 0x20 )
                         {
                             /* ûʹܱ־ */
                             USBHS_Dev_SleepStatus = 0x01;
                         }
                         else
                         {
                             errflag = 0xFF;
                         }
                     }
                     else
                     {
                         errflag = 0xFF;
                     }
                 }
                 else if( ( pMySetupReqPak->bRequestType & 0x1F ) == 0x02 )
                 {
                     /* ö˵ */
                     if( pMySetupReqPak->wValue == 0x00 )
                     {
                         /* ָ˵STALL */
                         switch( ( pMySetupReqPak->wIndex ) & 0xff )
                         {
                             case 0x83:
                                 /* ö˵3 IN STALL */
                                 USBHSD->UEP3_TX_CTRL = ( USBHSD->UEP3_TX_CTRL & ~USBHS_EP_T_RES_MASK ) | USBHS_EP_T_RES_STALL;
                                 break;

                             case 0x03:
                                 /* ö˵3 OUT Stall */
                                 USBHSD->UEP3_RX_CTRL = ( USBHSD->UEP3_RX_CTRL & ~USBHS_EP_R_RES_MASK ) | USBHS_EP_R_RES_STALL;
                                 break;

                             default:
                                 errflag = 0xFF;
                                 break;
                         }
                     }
                     else
                     {
                         errflag = 0xFF;
                     }
                 }
                 else
                 {
                     errflag = 0xFF;
                 }
                 break;

             case USB_GET_INTERFACE:
                 EP0_Databuf[ 0 ] = 0x00;
                 if( USBHS_Dev_SetupReqLen > 1 )
                 {
                     USBHS_Dev_SetupReqLen = 1;
                 }
                 break;

             case USB_SET_INTERFACE:
                 EP0_Databuf[ 0 ] = 0x00;
                 if( USBHS_Dev_SetupReqLen > 1 )
                 {
                     USBHS_Dev_SetupReqLen = 1;
                 }
                 USBHSD->UEP3_TX_LEN=0;
                 USBHSD->UEP3_RX_CTRL=0;
                 break;

             case USB_GET_STATUS:
                 /* ݵǰ˵ʵ״̬Ӧ */
                 EP0_Databuf[ 0 ] = 0x00;
                 EP0_Databuf[ 1 ] = 0x00;
                 if( pMySetupReqPak->wIndex == 0x81 )
                 {
                     if( ( USBHSD->UEP1_TX_CTRL & USBHS_EP_T_RES_MASK ) == USBHS_EP_T_RES_STALL )
                     {
                         EP0_Databuf[ 0 ] = 0x01;
                     }
                 }
                 else if( pMySetupReqPak->wIndex == 0x01 )
                 {
                     if( ( USBHSD->UEP1_RX_CTRL & USBHS_EP_R_RES_MASK ) == USBHS_EP_R_RES_STALL )
                     {
                         EP0_Databuf[ 0 ] = 0x01;
                     }
                 }
                 else if( pMySetupReqPak->wIndex == 0x82 )
                 {
                     if( ( USBHSD->UEP2_TX_CTRL & USBHS_EP_T_RES_MASK ) == USBHS_EP_T_RES_STALL )
                     {
                         EP0_Databuf[ 0 ] = 0x01;
                     }
                 }
                 else if( pMySetupReqPak->wIndex == 0x02 )
                 {
                     if( ( USBHSD->UEP2_RX_CTRL & USBHS_EP_R_RES_MASK ) == USBHS_EP_R_RES_STALL )
                     {
                         EP0_Databuf[ 0 ] = 0x01;
                     }
                 }
                 if( USBHS_Dev_SetupReqLen > 2 )
                 {
                     USBHS_Dev_SetupReqLen = 2;
                 }
                 break;

             default:
                 errflag = 0xff;
                 break;
         }
     }

     /* ˵0 */
     if( errflag == 0xFF )
     {
         /* IN - STALL / OUT - DATA - STALL */
         USBHS_Dev_SetupReqCode = 0xFF;
         USBHSD->UEP0_TX_LEN  = 0;
         USBHSD->UEP0_TX_CTRL = USBHS_EP_T_RES_STALL;
         USBHSD->UEP0_RX_CTRL = USBHS_EP_R_RES_STALL;
     }
     else
     {
         /* DATA stage (IN -DATA1-ACK) */
         if( chtype & 0x80 )
         {
             len = ( USBHS_Dev_SetupReqLen> DEF_USBD_UEP0_SIZE ) ? DEF_USBD_UEP0_SIZE : USBHS_Dev_SetupReqLen;
             USBHS_Dev_SetupReqLen -= len;
         }
         else
         {
             len = 0;
         }
         USBHSD->UEP0_TX_LEN  = len;
         USBHSD->UEP0_TX_CTRL = USBHS_EP_T_RES_ACK | USBHS_EP_T_TOG_1;
     }
     USBHSD->INT_FG = USBHS_SETUP_FLAG;
    }
    else if( USBHS_Int_Flag & USBHS_DETECT_FLAG )
    {
        /* USB߸λж */
#if 0
        printf("Rs\n");

#endif
        USBHS_Dev_Address = 0x00;
        USBHS_Device_Endp_Init( );                                              /* USB2.0豸˵ʼ */
        USBHS_Device_SetAddress( USBHS_Dev_Address );                           /* USB2.0豸豸ַ */
        USBHSD->INT_FG = USBHS_DETECT_FLAG;
    }
    else if( USBHS_Int_Flag & USBHS_SUSPEND_FLAG )
    {
        /*  */
#if 0
        printf("USB SUSPEND!!!\n");
#endif
        USBHS_Dev_SleepStatus &= ~0x02;
        USBHS_Dev_EnumStatus = 0x01;
        USBHSD->INT_FG = USBHS_SUSPEND_FLAG;
    }
}

